`timescale 1 ns/ 1 ns

module sign_mult_36x36 (
	clock0,
	dataa_0,
	datab_0,
	result);
	input   clock0;
	input   [35:0]  dataa_0;
	input   [35:0]  datab_0;
	output   [71:0]  result;

parameter dly = 1;	

reg [35:0] dataa_reg, datab_reg;
reg [71:0] result;
reg [35:0] tmp_a, tmp_b;

always @(posedge clock0) begin
	dataa_reg	<= # dly dataa_0;
	datab_reg	<= # dly datab_0;
end

always @(*) begin
	tmp_a	= dataa_reg[35] ? -dataa_reg : dataa_reg;
	tmp_b	= datab_reg[35] ? -datab_reg : datab_reg;
	result	= tmp_a*tmp_b;
	result	= (dataa_reg[35]^datab_reg[35]) ? -result : result;
end
	
endmodule
