`timescale 1ns/1ns

module freq_synthesizer_RAM( input clk, clrn,
	input [31:0] phase_adv,
	input wr,
	input [15:0] addr,
	input [31:0] data,
	output reg [18:0] dout);
	
parameter dly =1;

reg [39:0] phase;
reg [17:0] mem [255 : 0] /* synthesis syn_ramstyle="M4K" */;
wire [7:0] mem_addr_wr, mem_addr_rd;
reg [17:0] mem_out;

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin
		phase	<= # dly 40'h0;
	end else begin
		phase	<= # dly phase + phase_adv;
	end
end

assign mem_addr_wr	= addr[7:0];
assign mem_addr_rd	= phase[38] ? ~phase[37:30] : phase[37:30];

always @(posedge clk) begin
	if (wr) begin
		mem[mem_addr_wr] <= # dly data[17:0];
	end
end

always @(posedge clk) begin
	mem_out	<= # dly mem[mem_addr_rd];
end

always @(posedge clk) begin
	if (phase[39]) begin
		dout	<= # dly -{1'b0, mem_out};
	end else begin
		dout	<= # dly {1'b0, mem_out};
	end
end

endmodule	