`timescale 1ns/1ns

module vme_dout_arbiter (
	cs_int_manager, int_manager_data, int_manager_dav,
	cs_vwbtn, vwbtn_data, vwbtn_dav,
	cs_codec, codec_data, codec_dav,
	cs_vert_sram_master, vert_sram_master_data, vert_sram_master_dav,
	cs_hor_sram_master, hor_sram_master_data, hor_sram_master_dav,
	cs_pm_sram_master, pm_sram_master_data, pm_sram_master_dav,
	cs_w_mem, w_mem_data, w_mem_dav,
	cs_trigger_manager, trigger_manager_data, trigger_manager_dav,
	cs_cordic_win_1, cordic_win_1_data, cordic_win_1_dav,
	cs_cordic_win_2, cordic_win_2_data, cordic_win_2_dav,
	cs_cordic_win_3, cordic_win_3_data, cordic_win_3_dav,	
	cs_codec_control, codec_control_data, codec_control_dav,
	cs_fir_dec, fir_dec_data, fir_dec_dav,
	cs_debug_reg, debug_reg, debug_reg_dav,
	vme_data, vme_dav);
	
input cs_int_manager; 
input [31:0] int_manager_data; 
input int_manager_dav;

input cs_vwbtn; 
input [31:0] vwbtn_data; 
input vwbtn_dav;

input cs_codec;
input [31:0] codec_data;
input codec_dav;

input cs_vert_sram_master;
input [31:0] vert_sram_master_data;
input vert_sram_master_dav;

input cs_hor_sram_master;
input [31:0] hor_sram_master_data;
input hor_sram_master_dav;

input cs_pm_sram_master;
input [31:0] pm_sram_master_data;
input pm_sram_master_dav;

input cs_w_mem;
input [31:0] w_mem_data;
input w_mem_dav;

input cs_trigger_manager;
input [31:0] trigger_manager_data;
input trigger_manager_dav;

input cs_cordic_win_1;
input [31:0] cordic_win_1_data;
input cordic_win_1_dav;

input cs_cordic_win_2;
input [31:0] cordic_win_2_data;
input cordic_win_2_dav;

input cs_cordic_win_3;
input [31:0] cordic_win_3_data;
input cordic_win_3_dav;

input cs_codec_control;
input [31:0] codec_control_data;
input codec_control_dav;

input cs_fir_dec;
input [31:0] fir_dec_data;
input fir_dec_dav;

input cs_debug_reg; 
input [31:0] debug_reg; 
input debug_reg_dav;


output [31:0] vme_data;
output vme_dav;

reg [31:0] vme_data;
reg vme_dav;

always @(*) begin
	vme_data	= 32'hdead_beef;
	vme_dav		= 1'b0;
	if (cs_int_manager) begin
		vme_data	= int_manager_data;
		vme_dav		= int_manager_dav;
	end else if (cs_vwbtn) begin
		vme_data	= vwbtn_data;
		vme_dav		= vwbtn_dav;
	end else if (cs_codec) begin
		vme_data	= codec_data;
		vme_dav		= codec_dav;
	end else if (cs_vert_sram_master) begin
		vme_data	= vert_sram_master_data;
		vme_dav		= vert_sram_master_dav;
	end else if (cs_hor_sram_master) begin
		vme_data	= hor_sram_master_data;
		vme_dav		= hor_sram_master_dav;
	end else if (cs_pm_sram_master) begin
		vme_data	= pm_sram_master_data;
		vme_dav		= pm_sram_master_dav;
	end else if (cs_w_mem) begin
		vme_data	= w_mem_data;
		vme_dav		= w_mem_dav;
	end else if (cs_trigger_manager) begin
		vme_data	= trigger_manager_data;
		vme_dav		= trigger_manager_dav;
	end else if (cs_cordic_win_1) begin
		vme_data	= cordic_win_1_data;
		vme_dav		= cordic_win_1_dav;
	end else if (cs_cordic_win_2) begin
		vme_data	= cordic_win_2_data;
		vme_dav		= cordic_win_2_dav;
	end else if (cs_cordic_win_3) begin
		vme_data	= cordic_win_3_data;
		vme_dav		= cordic_win_3_dav;
	end else if (cs_codec_control) begin
		vme_data	= codec_control_data;
		vme_dav		= codec_control_dav;	
	end else if (cs_fir_dec) begin
		vme_data	= fir_dec_data;
		vme_dav		= fir_dec_dav;
	end else if (cs_debug_reg) begin
		vme_data	= debug_reg;
		vme_dav		= debug_reg_dav;
	end
end

endmodule	