`timescale 1ns/1ns

module vwbtn_control_module (
	input clk, clrn, cs, wr,
	input [13:0] data_in,
	output reg vwbtn_bscan1, vwbtn_bscan2,
	inout [11:0] vwbtn_d,
	output [31:0] vme_dout);
	
parameter dly = 1;

reg [11:0] vwbtn_d_int;

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin
		{vwbtn_bscan2, vwbtn_bscan1, vwbtn_d_int}	<= # dly {1'b1, 1'b1, 12'haaa};
	end else if (wr && cs) begin
		{vwbtn_bscan2, vwbtn_bscan1, vwbtn_d_int}	<= # dly data_in;
	end
end	

assign vwbtn_d	= (vwbtn_bscan2 || vwbtn_bscan1) ? vwbtn_d_int : 12'hz;

assign vme_dout	= {4'ha, vwbtn_d, 2'b0, vwbtn_bscan2, vwbtn_bscan1,vwbtn_d_int};

endmodule
