`timescale 1 ns/ 1 ns

module cmpl_mult_real_18x18 (
	clock0,
	dataa_0,
	dataa_1,
	datab_0,
	datab_1,
	result)/* synthesis synthesis_clearbox = 1 */;

	input	  clock0;
	input	[17:0]  dataa_0;
	input	[17:0]  dataa_1;
	input	[17:0]  datab_0;
	input	[17:0]  datab_1;
	output	[35:0]  result;

reg [35:0] result;	
	
parameter dly = 1;	
		
reg [34:0] prod0, prod1, tmp_p;
reg [17:0] tmp_a, tmp_b;

always @(*) begin
	tmp_a	= dataa_0[17] ? -dataa_0 : dataa_0;
	tmp_b	= datab_0[17] ? -datab_0 : datab_0;
	tmp_p	= tmp_a*tmp_b;
	prod0	= (dataa_0[17]^datab_0[17]) ? -tmp_p : tmp_p;
	tmp_a	= dataa_1[17] ? -dataa_1 : dataa_1;
	tmp_b	= datab_1[17] ? -datab_1 : datab_1;
	tmp_p	= tmp_a*tmp_b;
	prod1	= (dataa_1[17]^datab_1[17]) ? -tmp_p : tmp_p;
end

always @(posedge clock0) begin
	result	<= # dly prod1 - prod2;
end

endmodule