// megafunction wizard: %RAM: 2-PORT%VBB%
// GENERATION: STANDARD
// VERSION: WM1.0
// MODULE: altsyncram 
`timescale 1 ns/ 1 ns

module ram_dp_18x64k (
	data_a,
	wren_a,
	address_a,
	data_b,
	address_b,
	wren_b,
	clock,
	q_a,
	q_b);

	input	[17:0]  data_a;
	input	  wren_a;
	input	[15:0]  address_a;
	input	[17:0]  data_b;
	input	[15:0]  address_b;
	input	  wren_b;
	input	  clock;
	output	[17:0]  q_a;
	output	[17:0]  q_b;

	reg	[17:0]  q_a;
	reg	[17:0]  q_b;
	
	
reg [17:0] mem [65535:0];

parameter dly = 1;	
		
always @(posedge clock) q_a	<= # dly mem[address_a];
always @(posedge clock) q_b	<= # dly mem[address_b];

always @(posedge clock) begin
	if (wren_a) begin
		mem[address_a]	<= # dly data_a;
	end
	if (wren_b) begin
		mem[address_b]	<= # dly (address_b==address_a && wren_a) ? 18'hx : data_b;
	end
end
	
endmodule

