`timescale 1ns/1ns

module cordic_ampl_phy
	(input	clk,
	input 	clrn,
	
	input	[35:0] x_in,
	input	[35:0] y_in,

	input 	start,
	
	output	reg done,
	output	reg [35:0] ampl_out,
	output	reg [39:0] phase_out);
	
parameter atan_0	= 38'h2000000000;   
parameter atan_1	= 38'h12e4051d9e;   
parameter atan_2	= 38'h09fb385b5f;   
parameter atan_3	= 38'h051111d41e;
parameter atan_4	= 38'h028b0d430e;   
parameter atan_5	= 38'h0145d7e159;   
parameter atan_6	= 38'h00a2f61e5c;   
parameter atan_7	= 38'h00517c5512;
parameter atan_8	= 38'h0028be5347;   
parameter atan_9	= 38'h00145f2ebb;   
parameter atan_10	= 38'h000a2f9801;   
parameter atan_11	= 38'h000517cc15;
parameter atan_12	= 38'h00028be60d;  
parameter atan_13	= 38'h000145f307;   
parameter atan_14	= 38'h0000a2f983;   
parameter atan_15	= 38'h0000517cc2;
parameter atan_16	= 38'h000028be61;   
parameter atan_17	= 38'h0000145f30;   
parameter atan_18	= 38'h00000a2f98;   
parameter atan_19	= 38'h00000517cc;
parameter atan_20	= 38'h0000028be6;   
parameter atan_21	= 38'h00000145f3;   
parameter atan_22	= 38'h000000a2fa;   
parameter atan_23	= 38'h000000517d;
parameter atan_24	= 38'h00000028be;   
parameter atan_25	= 38'h000000145f;   
parameter atan_26	= 38'h0000000a30;   
parameter atan_27	= 38'h0000000518;
parameter atan_28	= 38'h000000028c;   
parameter atan_29	= 38'h0000000146;   
parameter atan_30	= 38'h00000000a3;   
parameter atan_31	= 38'h0000000051;
parameter atan_32	= 38'h0000000029;   
parameter atan_33	= 38'h0000000014;   
parameter atan_34	= 38'h000000000a;   
parameter atan_35	= 38'h0000000005;		

wire [38:0] atan [35:0];

assign atan[ 0]	= {1'b0, atan_0 };
assign atan[ 1]	= {1'b0, atan_1 };
assign atan[ 2]	= {1'b0, atan_2 };
assign atan[ 3]	= {1'b0, atan_3 };
assign atan[ 4]	= {1'b0, atan_4 };
assign atan[ 5]	= {1'b0, atan_5 };
assign atan[ 6]	= {1'b0, atan_6 };
assign atan[ 7]	= {1'b0, atan_7 };
assign atan[ 8]	= {1'b0, atan_8 };
assign atan[ 9]	= {1'b0, atan_9 };
assign atan[10]	= {1'b0, atan_10};   
assign atan[11]	= {1'b0, atan_11};
assign atan[12]	= {1'b0, atan_12};  
assign atan[13]	= {1'b0, atan_13};   
assign atan[14]	= {1'b0, atan_14};   
assign atan[15]	= {1'b0, atan_15};
assign atan[16]	= {1'b0, atan_16};   
assign atan[17]	= {1'b0, atan_17};   
assign atan[18]	= {1'b0, atan_18};   
assign atan[19]	= {1'b0, atan_19};
assign atan[20]	= {1'b0, atan_20};   
assign atan[21]	= {1'b0, atan_21};   
assign atan[22]	= {1'b0, atan_22};   
assign atan[23]	= {1'b0, atan_23};
assign atan[24]	= {1'b0, atan_24};   
assign atan[25]	= {1'b0, atan_25};   
assign atan[26]	= {1'b0, atan_26};   
assign atan[27]	= {1'b0, atan_27};
assign atan[28]	= {1'b0, atan_28};   
assign atan[29]	= {1'b0, atan_29};   
assign atan[30]	= {1'b0, atan_30};   
assign atan[31]	= {1'b0, atan_31};
assign atan[32]	= {1'b0, atan_32};   
assign atan[33]	= {1'b0, atan_33};   
assign atan[34]	= {1'b0, atan_34};   
assign atan[35]	= {1'b0, atan_35};


parameter dly=1;
				
reg	[5:0] counter;
reg [39:0] phase_acc;
reg [41:0] ex_y_in, ex_x_in;

//***********************************************
// FROM RECTANGULAR TO POLAR
//***********************************************



always @(posedge clk or negedge clrn) begin
	if (~clrn || counter==6'd36) begin 
		counter	<= # dly 6'd0;
	end else if (start || |counter) begin
		counter	<= # dly counter + 1'b1;
	end   
end

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin
		phase_acc	<= # dly 40'd0;
	end else case (counter)
		6'd0: begin
			if (x_in[35]) begin
				phase_acc	<= # dly ~y_in[35] ? 40'h80_0000_0000 - {1'b0, atan[0]} : 40'h80_0000_0000 + {1'b0, atan[0]};			
			end else begin	
				phase_acc	<= # dly y_in[35] ? -{1'b0, atan[0]} : {1'b0, atan[0]};
			end
		end	
		6'd1: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[1] } : phase_acc + {1'b0, atan[1] };	
		6'd2: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[2] } : phase_acc + {1'b0, atan[2] };
		6'd3: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[3] } : phase_acc + {1'b0, atan[3] };
		6'd4: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[4] } : phase_acc + {1'b0, atan[4] };
		6'd5: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[5] } : phase_acc + {1'b0, atan[5] };
		6'd6: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[6] } : phase_acc + {1'b0, atan[6] };
		6'd7: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[7] } : phase_acc + {1'b0, atan[7] };
		6'd8: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[8] } : phase_acc + {1'b0, atan[8] };
		6'd9: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[9] } : phase_acc + {1'b0, atan[9] };
		6'd10: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[10]} : phase_acc + {1'b0, atan[10]};
		6'd11: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[11]} : phase_acc + {1'b0, atan[11]};
		6'd12: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[12]} : phase_acc + {1'b0, atan[12]};
		6'd13: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[13]} : phase_acc + {1'b0, atan[13]};
		6'd14: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[14]} : phase_acc + {1'b0, atan[14]};
		6'd15: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[15]} : phase_acc + {1'b0, atan[15]};
		6'd16: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[16]} : phase_acc + {1'b0, atan[16]};
		6'd17: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[17]} : phase_acc + {1'b0, atan[17]};
		6'd18: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[18]} : phase_acc + {1'b0, atan[18]};
		6'd19: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[19]} : phase_acc + {1'b0, atan[19]};
		6'd20: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[20]} : phase_acc + {1'b0, atan[20]};
		6'd21:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[21]} : phase_acc + {1'b0, atan[21]};
		6'd22: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[22]} : phase_acc + {1'b0, atan[22]};
		6'd23:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[23]} : phase_acc + {1'b0, atan[23]};
		6'd24: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[24]} : phase_acc + {1'b0, atan[24]};
		6'd25: 	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[25]} : phase_acc + {1'b0, atan[25]};
		6'd26:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[26]} : phase_acc + {1'b0, atan[26]};
		6'd27:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[27]} : phase_acc + {1'b0, atan[27]};
		6'd28:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[28]} : phase_acc + {1'b0, atan[28]};
		6'd29:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[29]} : phase_acc + {1'b0, atan[29]};
		6'd30:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[30]} : phase_acc + {1'b0, atan[30]};
		6'd31:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[31]} : phase_acc + {1'b0, atan[31]};
		6'd32:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[32]} : phase_acc + {1'b0, atan[32]};
		6'd33:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[33]} : phase_acc + {1'b0, atan[33]};
		6'd34:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[34]} : phase_acc + {1'b0, atan[34]};
		6'd35:	phase_acc	<= # dly ex_y_in[41] ? phase_acc - {1'b0, atan[35]} : phase_acc + {1'b0, atan[35]};
	endcase
end

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin
		ex_x_in		<= # dly 42'd0;
		ex_y_in		<= # dly 42'd0;
	end else case (counter)
		6'd0: begin
			if (x_in[35]) begin   
				ex_x_in	<= # dly ~y_in[35] ? -{ x_in, 6'b0} + {y_in, 6'b0} : -{x_in, 6'b0} - {y_in, 6'b0};
				ex_y_in	<= # dly ~y_in[35] ? -{y_in, 6'b0} - {x_in, 6'b0} : -{y_in, 6'b0} + {x_in, 6'b0};
			end else begin
				ex_x_in	<= # dly y_in[35] ? {x_in, 6'b0} - {y_in, 6'b0} : {x_in, 6'b0} + {y_in, 6'b0};
				ex_y_in	<= # dly y_in[35] ? {y_in, 6'b0} + {x_in, 6'b0} : {y_in, 6'b0} - {x_in, 6'b0};
			end		
		end			
		6'd1: begin
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{1{ex_y_in[41]}}, ex_y_in[41:1]} : ex_x_in + {{1{ex_y_in[41]}}, ex_y_in[41:1]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{1{ex_x_in[41]}}, ex_x_in[41:1]} : ex_y_in - {{1{ex_x_in[41]}}, ex_x_in[41:1]};
		end	        	                                                                                                                      
		6'd2: begin 	                                                                                                                      
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{2{ex_y_in[41]}}, ex_y_in[41:2]} : ex_x_in + {{2{ex_y_in[41]}}, ex_y_in[41:2]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{2{ex_x_in[41]}}, ex_x_in[41:2]} : ex_y_in - {{2{ex_x_in[41]}}, ex_x_in[41:2]};
		end	        	                                                                                                                      
		6'd3: begin 	                                                                                                                      
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{3{ex_y_in[41]}}, ex_y_in[41:3]} : ex_x_in + {{3{ex_y_in[41]}}, ex_y_in[41:3]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{3{ex_x_in[41]}}, ex_x_in[41:3]} : ex_y_in - {{3{ex_x_in[41]}}, ex_x_in[41:3]};
		end		    	                                                                                                                      
		6'd4: begin 	                                                                                                                      
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{4{ex_y_in[41]}}, ex_y_in[41:4]} : ex_x_in + {{4{ex_y_in[41]}}, ex_y_in[41:4]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{4{ex_x_in[41]}}, ex_x_in[41:4]} : ex_y_in - {{4{ex_x_in[41]}}, ex_x_in[41:4]};
		end		    	                                                                                                                      
		6'd5: begin 	                                                                                                                      
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{5{ex_y_in[41]}}, ex_y_in[41:5]} : ex_x_in + {{5{ex_y_in[41]}}, ex_y_in[41:5]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{5{ex_x_in[41]}}, ex_x_in[41:5]} : ex_y_in - {{5{ex_x_in[41]}}, ex_x_in[41:5]};
		end		    	                                                                                                                     
		6'd6: begin 	                                                                                                                      
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{6{ex_y_in[41]}}, ex_y_in[41:6]} : ex_x_in + {{6{ex_y_in[41]}}, ex_y_in[41:6]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{6{ex_x_in[41]}}, ex_x_in[41:6]} : ex_y_in - {{6{ex_x_in[41]}}, ex_x_in[41:6]};
		end		    	                                                                                                                      
		6'd7: begin 	                                                                                                                      
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{7{ex_y_in[41]}}, ex_y_in[41:7]} : ex_x_in + {{7{ex_y_in[41]}}, ex_y_in[41:7]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{7{ex_x_in[41]}}, ex_x_in[41:7]} : ex_y_in - {{7{ex_x_in[41]}}, ex_x_in[41:7]};
		end		    	                                                                                                                      
		6'd8: begin 	                                                                                                                      
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{8{ex_y_in[41]}}, ex_y_in[41:8]} : ex_x_in + {{8{ex_y_in[41]}}, ex_y_in[41:8]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{8{ex_x_in[41]}}, ex_x_in[41:8]} : ex_y_in - {{8{ex_x_in[41]}}, ex_x_in[41:8]};
		end		    	                                                                                                                      
		6'd9: begin 	                                                                                                                      
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{9{ex_y_in[41]}}, ex_y_in[41:9]} : ex_x_in + {{9{ex_y_in[41]}}, ex_y_in[41:9]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{9{ex_x_in[41]}}, ex_x_in[41:9]} : ex_y_in - {{9{ex_x_in[41]}}, ex_x_in[41:9]};
		end		    	
		6'd10: begin	
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{10{ex_y_in[41]}}, ex_y_in[41:10]} :  ex_x_in + {{10{ex_y_in[41]}}, ex_y_in[41:10]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{10{ex_x_in[41]}}, ex_x_in[41:10]} :  ex_y_in - {{10{ex_x_in[41]}}, ex_x_in[41:10]};
		end		    	                                                                                                                           
		6'd11: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{11{ex_y_in[41]}}, ex_y_in[41:11]} : ex_x_in + {{11{ex_y_in[41]}}, ex_y_in[41:11]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{11{ex_x_in[41]}}, ex_x_in[41:11]} : ex_y_in - {{11{ex_x_in[41]}}, ex_x_in[41:11]};
		end		    	                                                                                                                           
		6'd12: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{12{ex_y_in[41]}}, ex_y_in[41:12]} : ex_x_in + {{12{ex_y_in[41]}}, ex_y_in[41:12]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{12{ex_x_in[41]}}, ex_x_in[41:12]} : ex_y_in - {{12{ex_x_in[41]}}, ex_x_in[41:12]};
		end		    	                                                                                                                           
		6'd13: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{13{ex_y_in[41]}}, ex_y_in[41:13]} : ex_x_in + {{13{ex_y_in[41]}}, ex_y_in[41:13]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{13{ex_x_in[41]}}, ex_x_in[41:13]} : ex_y_in - {{13{ex_x_in[41]}}, ex_x_in[41:13]};
		end		    	                                                                                                                           
		6'd14: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{14{ex_y_in[41]}}, ex_y_in[41:14]} : ex_x_in + {{14{ex_y_in[41]}}, ex_y_in[41:14]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{14{ex_x_in[41]}}, ex_x_in[41:14]} : ex_y_in - {{14{ex_x_in[41]}}, ex_x_in[41:14]};
		end		    	                                                                                                                           
		6'd15: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{15{ex_y_in[41]}}, ex_y_in[41:15]} : ex_x_in + {{15{ex_y_in[41]}}, ex_y_in[41:15]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{15{ex_x_in[41]}}, ex_x_in[41:15]} : ex_y_in - {{15{ex_x_in[41]}}, ex_x_in[41:15]};
		end		    	                                                                                                                           
		6'd16: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{16{ex_y_in[41]}}, ex_y_in[41:16]} : ex_x_in + {{16{ex_y_in[41]}}, ex_y_in[41:16]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{16{ex_x_in[41]}}, ex_x_in[41:16]} : ex_y_in - {{16{ex_x_in[41]}}, ex_x_in[41:16]};
		end		    	                                                                                                                           
		6'd17: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{17{ex_y_in[41]}}, ex_y_in[41:17]} : ex_x_in + {{17{ex_y_in[41]}}, ex_y_in[41:17]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{17{ex_x_in[41]}}, ex_x_in[41:17]} : ex_y_in - {{17{ex_x_in[41]}}, ex_x_in[41:17]};
		end         	                                                                                                                           
		6'd18: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{18{ex_y_in[41]}}, ex_y_in[41:18]} : ex_x_in + {{18{ex_y_in[41]}}, ex_y_in[41:18]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{18{ex_x_in[41]}}, ex_x_in[41:18]} : ex_y_in - {{18{ex_x_in[41]}}, ex_x_in[41:18]};
		end		    	                                                                                                                        
		6'd19: begin	                                                                                                                        
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{19{ex_y_in[41]}}, ex_y_in[41:19]} : ex_x_in + {{19{ex_y_in[41]}}, ex_y_in[41:19]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{19{ex_x_in[41]}}, ex_x_in[41:19]} : ex_y_in - {{19{ex_x_in[41]}}, ex_x_in[41:19]};
		end		    	                                                                                                                           
		6'd20: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{20{ex_y_in[41]}}, ex_y_in[41:20]} : ex_x_in + {{20{ex_y_in[41]}}, ex_y_in[41:20]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{20{ex_x_in[41]}}, ex_x_in[41:20]} : ex_y_in - {{20{ex_x_in[41]}}, ex_x_in[41:20]};
		end		    	                                                                                                                           
		6'd21: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{21{ex_y_in[41]}}, ex_y_in[41:21]} : ex_x_in + {{21{ex_y_in[41]}}, ex_y_in[41:21]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{21{ex_x_in[41]}}, ex_x_in[41:21]} : ex_y_in - {{21{ex_x_in[41]}}, ex_x_in[41:21]};
		end		    	                                                                                                                           
		6'd22: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{22{ex_y_in[41]}}, ex_y_in[41:22]} : ex_x_in + {{22{ex_y_in[41]}}, ex_y_in[41:22]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{22{ex_x_in[41]}}, ex_x_in[41:22]} : ex_y_in - {{22{ex_x_in[41]}}, ex_x_in[41:22]};
		end	        	                                                                                                                           
		6'd23: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{23{ex_y_in[41]}}, ex_y_in[41:23]} : ex_x_in + {{23{ex_y_in[41]}}, ex_y_in[41:23]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{23{ex_x_in[41]}}, ex_x_in[41:23]} : ex_y_in - {{23{ex_x_in[41]}}, ex_x_in[41:23]};
		end	        	                                                                                                                           
		6'd24: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{24{ex_y_in[41]}}, ex_y_in[41:24]} : ex_x_in + {{24{ex_y_in[41]}}, ex_y_in[41:24]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{24{ex_x_in[41]}}, ex_x_in[41:24]} : ex_y_in - {{24{ex_x_in[41]}}, ex_x_in[41:24]};
		end	        	                                                                                                                           
		6'd25: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{25{ex_y_in[41]}}, ex_y_in[41:25]} : ex_x_in + {{25{ex_y_in[41]}}, ex_y_in[41:25]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{25{ex_x_in[41]}}, ex_x_in[41:25]} : ex_y_in - {{25{ex_x_in[41]}}, ex_x_in[41:25]};
		end		    	                                                                                                                           
		6'd26: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{26{ex_y_in[41]}}, ex_y_in[41:26]} : ex_x_in + {{26{ex_y_in[41]}}, ex_y_in[41:26]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{26{ex_x_in[41]}}, ex_x_in[41:26]} : ex_y_in - {{26{ex_x_in[41]}}, ex_x_in[41:26]};
		end		    	                                                                                                                           
		6'd27: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{27{ex_y_in[41]}}, ex_y_in[41:27]} : ex_x_in + {{27{ex_y_in[41]}}, ex_y_in[41:27]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{27{ex_x_in[41]}}, ex_x_in[41:27]} : ex_y_in - {{27{ex_x_in[41]}}, ex_x_in[41:27]};
		end		    	                                                                                                                        
		6'd28: begin	                                                                                                                        
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{28{ex_y_in[41]}}, ex_y_in[41:28]} : ex_x_in + {{28{ex_y_in[41]}}, ex_y_in[41:28]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{28{ex_x_in[41]}}, ex_x_in[41:28]} : ex_y_in - {{28{ex_x_in[41]}}, ex_x_in[41:28]};
		end		    	                                                                                                                           
		6'd29: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{29{ex_y_in[41]}}, ex_y_in[41:29]} : ex_x_in + {{29{ex_y_in[41]}}, ex_y_in[41:29]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{29{ex_x_in[41]}}, ex_x_in[41:29]} : ex_y_in - {{29{ex_x_in[41]}}, ex_x_in[41:29]};
		end		    	                                                                                                                           
		6'd30: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{30{ex_y_in[41]}}, ex_y_in[41:30]} : ex_x_in + {{30{ex_y_in[41]}}, ex_y_in[41:30]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{30{ex_x_in[41]}}, ex_x_in[41:30]} : ex_y_in - {{30{ex_x_in[41]}}, ex_x_in[41:30]};
		end		    	                                                                                                                           
		6'd31: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{31{ex_y_in[41]}}, ex_y_in[41:31]} : ex_x_in + {{31{ex_y_in[41]}}, ex_y_in[41:31]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{31{ex_x_in[41]}}, ex_x_in[41:31]} : ex_y_in - {{31{ex_x_in[41]}}, ex_x_in[41:31]};
		end		    	                                                                                                                           
		6'd32: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{32{ex_y_in[41]}}, ex_y_in[41:32]} : ex_x_in + {{32{ex_y_in[41]}}, ex_y_in[41:32]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{32{ex_x_in[41]}}, ex_x_in[41:32]} : ex_y_in - {{32{ex_x_in[41]}}, ex_x_in[41:32]};
		end		    	                                                                                                                           
		6'd33: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{33{ex_y_in[41]}}, ex_y_in[41:33]} : ex_x_in + {{33{ex_y_in[41]}}, ex_y_in[41:33]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{33{ex_x_in[41]}}, ex_x_in[41:33]} : ex_y_in - {{33{ex_x_in[41]}}, ex_x_in[41:33]};
		end		    	                                                                                                                           
		6'd34: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{34{ex_y_in[41]}}, ex_y_in[41:34]} : ex_x_in + {{34{ex_y_in[41]}}, ex_y_in[41:34]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{34{ex_x_in[41]}}, ex_x_in[41:34]} : ex_y_in - {{34{ex_x_in[41]}}, ex_x_in[41:34]};
		end		    	                                                                                                                           
		6'd35: begin	                                                                                                                           
			ex_x_in	<= # dly ex_y_in[41] ? ex_x_in - {{35{ex_y_in[41]}}, ex_y_in[41:35]} : ex_x_in + {{35{ex_y_in[41]}}, ex_y_in[41:35]};
			ex_y_in	<= # dly ex_y_in[41] ? ex_y_in + {{35{ex_x_in[41]}}, ex_x_in[41:35]} : ex_y_in - {{35{ex_x_in[41]}}, ex_x_in[41:35]};
		end                                                                                        
	endcase                                                                                        
end                                                                                               
 

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin 	
		done		<= # dly 1'b0;
		ampl_out	<= # dly 36'h0;
		phase_out	<= # dly 40'h0;
	end else begin
		done	<= # dly counter==6'd36;		 
		if (counter==6'd36) begin 	
			ampl_out	<= # dly ex_x_in[41:6];
			phase_out	<= # dly phase_acc;
		end
	end
end						

                                                                                                
endmodule