`timescale 1ns/1ns

module cordic_demodulator
	(input	clk,
	input 	clrn,
	
	input	[39:0] phase_pll,
	input	[41:0] ampl_pll,
	input	[39:0] phase_pll_dly,	
	input	[41:0] ampl_i,
	input	[41:0] ampl_q,
	input	[39:0] phase_mod,
	input	[39:0] phase_se1,
	input	[39:0] phase_se2,
	input	[41:0] ampl_se12,
	
	input 	start,
	
	output	reg done_pll,
	output	reg [35:0] cos_out_pll,
	output	reg [35:0] sin_out_pll,
	output	reg [35:0] cos_out_se1,
	output	reg [35:0] sin_out_se1,
	output	reg [35:0] cos_out_se2,
	output	reg [35:0] sin_out_se2,
	
	output	reg done_iq,
	output	reg [35:0] ampl_out_i,
	output	reg [39:0] phase_out_i,
	output	reg [35:0] ampl_out_q,
	output	reg [39:0] phase_out_q,
	output	reg [35:0] ampl_out_se1,
	output	reg [39:0] phase_out_se1,
	output	reg [35:0] ampl_out_se2,
	output	reg [39:0] phase_out_se2,	
	
	output	[35:0] demod_phy_out,
	output	reg [35:0] phy_mod_ampl,
	output	reg [35:0] mcginn_phy_out);	
	
//parameter ampl_pll	= 42'h136_e9db_5080; //for maximum amplitude out on 36 bits
	
parameter atan_0	= 38'h2000000000;   
parameter atan_1	= 38'h12e4051d9e;   
parameter atan_2	= 38'h09fb385b5f;   
parameter atan_3	= 38'h051111d41e;
parameter atan_4	= 38'h028b0d430e;   
parameter atan_5	= 38'h0145d7e159;   
parameter atan_6	= 38'h00a2f61e5c;   
parameter atan_7	= 38'h00517c5512;
parameter atan_8	= 38'h0028be5347;   
parameter atan_9	= 38'h00145f2ebb;   
parameter atan_10	= 38'h000a2f9801;   
parameter atan_11	= 38'h000517cc15;
parameter atan_12	= 38'h00028be60d;  
parameter atan_13	= 38'h000145f307;   
parameter atan_14	= 38'h0000a2f983;   
parameter atan_15	= 38'h0000517cc2;
parameter atan_16	= 38'h000028be61;   
parameter atan_17	= 38'h0000145f30;   
parameter atan_18	= 38'h00000a2f98;   
parameter atan_19	= 38'h00000517cc;
parameter atan_20	= 38'h0000028be6;   
parameter atan_21	= 38'h00000145f3;   
parameter atan_22	= 38'h000000a2fa;   
parameter atan_23	= 38'h000000517d;
parameter atan_24	= 38'h00000028be;   
parameter atan_25	= 38'h000000145f;   
parameter atan_26	= 38'h0000000a30;   
parameter atan_27	= 38'h0000000518;
parameter atan_28	= 38'h000000028c;   
parameter atan_29	= 38'h0000000146;   
parameter atan_30	= 38'h00000000a3;   
parameter atan_31	= 38'h0000000051;
parameter atan_32	= 38'h0000000029;   
parameter atan_33	= 38'h0000000014;   
parameter atan_34	= 38'h000000000a;   
parameter atan_35	= 38'h0000000005;		

wire [38:0] atan [35:0];

assign atan[ 0]	= {1'b0, atan_0 };
assign atan[ 1]	= {1'b0, atan_1 };
assign atan[ 2]	= {1'b0, atan_2 };
assign atan[ 3]	= {1'b0, atan_3 };
assign atan[ 4]	= {1'b0, atan_4 };
assign atan[ 5]	= {1'b0, atan_5 };
assign atan[ 6]	= {1'b0, atan_6 };
assign atan[ 7]	= {1'b0, atan_7 };
assign atan[ 8]	= {1'b0, atan_8 };
assign atan[ 9]	= {1'b0, atan_9 };
assign atan[10]	= {1'b0, atan_10};   
assign atan[11]	= {1'b0, atan_11};
assign atan[12]	= {1'b0, atan_12};  
assign atan[13]	= {1'b0, atan_13};   
assign atan[14]	= {1'b0, atan_14};   
assign atan[15]	= {1'b0, atan_15};
assign atan[16]	= {1'b0, atan_16};   
assign atan[17]	= {1'b0, atan_17};   
assign atan[18]	= {1'b0, atan_18};   
assign atan[19]	= {1'b0, atan_19};
assign atan[20]	= {1'b0, atan_20};   
assign atan[21]	= {1'b0, atan_21};   
assign atan[22]	= {1'b0, atan_22};   
assign atan[23]	= {1'b0, atan_23};
assign atan[24]	= {1'b0, atan_24};   
assign atan[25]	= {1'b0, atan_25};   
assign atan[26]	= {1'b0, atan_26};   
assign atan[27]	= {1'b0, atan_27};
assign atan[28]	= {1'b0, atan_28};   
assign atan[29]	= {1'b0, atan_29};   
assign atan[30]	= {1'b0, atan_30};   
assign atan[31]	= {1'b0, atan_31};
assign atan[32]	= {1'b0, atan_32};   
assign atan[33]	= {1'b0, atan_33};   
assign atan[34]	= {1'b0, atan_34};   
assign atan[35]	= {1'b0, atan_35};


parameter dly=1;

reg	[4:0] counter_pll;

reg [39:0] cordic_rotator_phy;
reg [41:0] cordic_rotator_ampl;
wire [35:0] cordic_rotator_sin, cordic_rotator_cos;

reg [35:0] cos_out_i, sin_out_i, sin_out_q, cos_out_q;
reg [35:0] cos_out_i_nlp, sin_out_i_nlp;
reg [35:0] cos_out_i_wlp, sin_out_i_wlp;
reg [35:0] phy_mod_cos, phy_mod_sin;
reg	[39:0] demod_phy;
reg [35:0] cos_out_i_se1, sin_out_i_se1;
reg [35:0] cos_out_i_se2, sin_out_i_se2;


//***********************************************
// SIN AND COS CALCULATION AND MIXER
//***********************************************

wire rot_done;
reg rot_done_old;
wire rot_start;

always @(posedge clk) begin
	rot_done_old	<= # dly rot_done;
end

assign rot_start	= start || (rot_done && ~rot_done_old && (counter_pll!=4'd8));

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin 
		counter_pll	<= # dly 4'd0;
	end else if (start) begin //to assure the synch
		counter_pll	<= # dly 4'd1;
	end else if (rot_done && ~rot_done_old) begin
		if (counter_pll==4'd8) begin
			counter_pll	<= # dly 4'd0;
		end else begin	
			counter_pll	<= # dly counter_pll + 1'b1;
		end
	end   
end

always @(posedge clk) begin
	if 	(counter_pll==4'd0) begin
		cordic_rotator_phy	<= # dly phase_pll;
	end else if (counter_pll==4'd1) begin
		cordic_rotator_phy	<= # dly phase_pll_dly;
	end else if (counter_pll==4'd3) begin
		cordic_rotator_phy	<= # dly phase_mod;
	end else if (counter_pll==4'd4) begin
		cordic_rotator_phy	<= # dly phase_se1;
	end else if (counter_pll==4'd5) begin
		cordic_rotator_phy	<= # dly phase_se2;
	end else if (counter_pll==4'd6) begin
		cordic_rotator_phy	<= # dly phase_se1;
	end else if (counter_pll==4'd7) begin
		cordic_rotator_phy	<= # dly phase_se2;
	end
end

always @(posedge clk) begin
	case (counter_pll) 
		3'd0: cordic_rotator_ampl	<= # dly ampl_pll;
		3'd1: cordic_rotator_ampl	<= # dly ampl_i;
		3'd2: cordic_rotator_ampl	<= # dly ampl_q;
		3'd3: cordic_rotator_ampl	<= # dly {2'b0, demod_phy} 	- {2'b0, phase_out_i};
		3'd4: cordic_rotator_ampl	<= # dly ampl_se12;
		3'd5: cordic_rotator_ampl	<= # dly ampl_se12;
		3'd6: cordic_rotator_ampl	<= # dly ampl_i;
		3'd7: cordic_rotator_ampl	<= # dly ampl_i;		
		default: cordic_rotator_ampl	<= # dly 42'h0;
	endcase
end
		
cordic_rotator_folded cordic_rotator
	(.clk(clk),
	.clrn(clrn),
	.start_value(cordic_rotator_ampl),
	.phase_in(cordic_rotator_phy),
	.start(rot_start),
	.done(rot_done),	
	.cos_out(cordic_rotator_cos),
	.sin_out(cordic_rotator_sin));

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin 	
		done_pll	<= # dly 1'b0;
		cos_out_pll	<= # dly 36'h0;
		sin_out_pll	<= # dly 36'h0;
		cos_out_i	<= # dly 36'h0;
		sin_out_i	<= # dly 36'h0;
		cos_out_q	<= # dly 36'h0;
		sin_out_q	<= # dly 36'h0;
		cos_out_i_nlp	<= # dly 36'h0;
		sin_out_i_nlp	<= # dly 36'h0;
		cos_out_i_wlp	<= # dly 36'h0;
		sin_out_i_wlp	<= # dly 36'h0;
		cos_out_i_se1	<= # dly 36'h0;
		sin_out_i_se1	<= # dly 36'h0;
		cos_out_i_se2	<= # dly 36'h0;
		sin_out_i_se2	<= # dly 36'h0;
	end else begin
		done_pll	<= # dly (counter_pll==4'd8)&&(rot_done && ~rot_done_old);	
		if (rot_done && ~rot_done_old) begin
			if (counter_pll==4'd1) begin 	
				cos_out_pll	<= # dly cordic_rotator_cos;
				sin_out_pll	<= # dly cordic_rotator_sin;
			end else if (counter_pll==4'd2) begin 
				cos_out_i	<= # dly cos_out_i - {{10{cos_out_i[35]}}, cos_out_i[35:10]} + {{10{cordic_rotator_cos[35]}}, cordic_rotator_cos[35:10]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/1024; 
				sin_out_i	<= # dly sin_out_i - {{10{sin_out_i[35]}}, sin_out_i[35:10]} + {{10{cordic_rotator_sin[35]}}, cordic_rotator_sin[35:10]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/1024; 
				cos_out_i_nlp	<= # dly cordic_rotator_cos;
				sin_out_i_nlp	<= # dly cordic_rotator_sin;
				cos_out_i_wlp	<= # dly cos_out_i_wlp - {{2{cos_out_i_wlp[35]}}, cos_out_i_wlp[35:2]} + {{2{cordic_rotator_cos[35]}}, cordic_rotator_cos[35:2]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/4; 
				sin_out_i_wlp	<= # dly sin_out_i_wlp - {{2{sin_out_i_wlp[35]}}, sin_out_i_wlp[35:2]} + {{2{cordic_rotator_sin[35]}}, cordic_rotator_sin[35:2]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/4; 
			end else if (counter_pll==4'd3) begin 
				cos_out_q	<= # dly cos_out_q - {{10{cos_out_q[35]}}, cos_out_q[35:10]} + {{10{cordic_rotator_cos[35]}}, cordic_rotator_cos[35:10]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/1024; 
				sin_out_q	<= # dly sin_out_q - {{10{sin_out_q[35]}}, sin_out_q[35:10]} + {{10{cordic_rotator_sin[35]}}, cordic_rotator_sin[35:10]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/1024; 
			end else if (counter_pll==4'd4) begin 
				phy_mod_cos	<= # dly phy_mod_cos - {{12{phy_mod_cos[35]}}, phy_mod_cos[35:12]} + {{12{cordic_rotator_cos[35]}}, cordic_rotator_cos[35:12]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/4096; 
				phy_mod_sin	<= # dly phy_mod_sin - {{12{phy_mod_sin[35]}}, phy_mod_sin[35:12]} + {{12{cordic_rotator_sin[35]}}, cordic_rotator_sin[35:12]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/4096; 
			end else if (counter_pll==4'd5) begin 
				cos_out_se1	<= # dly cordic_rotator_cos;
				sin_out_se1	<= # dly cordic_rotator_sin;
			end else if (counter_pll==4'd6) begin 
				cos_out_se2	<= # dly cordic_rotator_cos;
				sin_out_se2	<= # dly cordic_rotator_sin;
			end else if (counter_pll==4'd7) begin 
				cos_out_i_se1	<= # dly cos_out_i_se1 - {{14{cos_out_i_se1[35]}}, cos_out_i_se1[35:14]} + {{14{cordic_rotator_cos[35]}}, cordic_rotator_cos[35:14]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/1024; 
				sin_out_i_se1	<= # dly sin_out_i_se1 - {{14{sin_out_i_se1[35]}}, sin_out_i_se1[35:14]} + {{14{cordic_rotator_sin[35]}}, cordic_rotator_sin[35:14]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/1024; 
			end else if (counter_pll==4'd8) begin 
				cos_out_i_se2	<= # dly cos_out_i_se2 - {{14{cos_out_i_se2[35]}}, cos_out_i_se2[35:14]} + {{14{cordic_rotator_cos[35]}}, cordic_rotator_cos[35:14]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/1024; 
				sin_out_i_se2	<= # dly sin_out_i_se2 - {{14{sin_out_i_se2[35]}}, sin_out_i_se2[35:14]} + {{14{cordic_rotator_sin[35]}}, cordic_rotator_sin[35:14]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/1024; 
			end 					
		end 	
	end
end						

//***********************************************
// FROM RECTANGULAR TO POLAR
//***********************************************

reg [2:0] counter_iq;
wire ampl_phy_done;
reg start_ampl_phy;
reg ampl_phy_done_old;
reg [35:0] x_in_derot, y_in_derot;
wire [35:0] ampl_out;
wire [39:0] phase_out;

always @(posedge clk) begin
	ampl_phy_done_old	<= # dly ampl_phy_done;
end	

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin 	
		done_iq			<= # dly 1'b0;
		ampl_out_i		<= # dly 36'h0;
		phase_out_i		<= # dly 40'h0;
		ampl_out_se1	<= # dly 36'h0;
		phase_out_se1	<= # dly 40'h0;
		ampl_out_se2	<= # dly 36'h0;
		phase_out_se2	<= # dly 40'h0;
		ampl_out_q		<= # dly 36'h0;
		phase_out_q		<= # dly 40'h0;
		counter_iq		<= # dly 3'd0;
		start_ampl_phy	<= # dly 1'b0;
		x_in_derot		<= # dly 36'h0;
		y_in_derot		<= # dly 36'h0;	
		demod_phy		<= # dly 40'h0;
		mcginn_phy_out	<= # dly 36'h0;
		phy_mod_ampl	<= # dly 36'h0;
	end else if (done_pll) begin
		counter_iq		<= # dly 3'd1;
		start_ampl_phy	<= # dly 1'b1;
		x_in_derot		<= # dly cos_out_i;
		y_in_derot		<= # dly sin_out_i;
		done_iq			<= # dly 1'b0;					
	end else if (ampl_phy_done &&  ~ampl_phy_done_old) begin	
		case (counter_iq) 
			3'd1: begin
				counter_iq		<= # dly counter_iq + 1'b1;
				start_ampl_phy	<= # dly 1'b1;
				x_in_derot		<= # dly cos_out_q;
				y_in_derot		<= # dly sin_out_q;
				ampl_out_i		<= # dly ampl_out;
				phase_out_i		<= # dly phase_out;	
				done_iq			<= # dly 1'b0;						
			end
			3'd2: begin
				counter_iq		<= # dly counter_iq + 1'b1;
				start_ampl_phy	<= # dly 1'b1;
				x_in_derot		<= # dly cos_out_i_nlp;
				y_in_derot		<= # dly sin_out_i_nlp;
				ampl_out_q		<= # dly ampl_out;
				phase_out_q		<= # dly phase_out;
				done_iq			<= # dly 1'b0;
			end
			3'd3: begin
				counter_iq		<= # dly counter_iq + 1'b1;
				start_ampl_phy	<= # dly 1'b1;
//				x_in_derot		<= # dly cos_out_i_wlp;
//				y_in_derot		<= # dly sin_out_i_wlp;
				x_in_derot		<= # dly cos_out_i_nlp;
				y_in_derot		<= # dly sin_out_i_nlp;
				mcginn_phy_out	<= # dly phase_out[39:0];
				done_iq			<= # dly 1'b0;
			end
			3'd4: begin
				counter_iq		<= # dly counter_iq + 1'b1;
				start_ampl_phy	<= # dly 1'b1;
				x_in_derot		<= # dly phy_mod_cos;
				y_in_derot		<= # dly phy_mod_sin;
				demod_phy		<= # dly phase_out[39:0];
				done_iq			<= # dly 1'b0;
			end
			3'd5: begin
				counter_iq		<= # dly counter_iq + 1'b1;
				start_ampl_phy	<= # dly 1'b1;
				x_in_derot		<= # dly cos_out_i_se1;
				y_in_derot		<= # dly sin_out_i_se1;
//				phy_mod_ampl	<= # dly ampl_out;
				phy_mod_ampl	<= # dly phy_mod_ampl - {{10{phy_mod_ampl[35]}}, phy_mod_ampl[35:10]} + {{10{ampl_out[35]}}, ampl_out[35:10]}; //LP IIR : H(z)=(1-a)/(1-a*z^-1) ; a=1-1/1024; 		
				done_iq			<= # dly 1'b0;
			end
			3'd6: begin
				counter_iq		<= # dly counter_iq + 1'b1;
				start_ampl_phy	<= # dly 1'b1;
				x_in_derot		<= # dly cos_out_i_se2;
				y_in_derot		<= # dly sin_out_i_se2;
				ampl_out_se1	<= # dly ampl_out;
				phase_out_se1	<= # dly phase_out;	
				done_iq			<= # dly 1'b0;						

			end
			3'd7: begin
				counter_iq		<= # dly 3'b0;
				start_ampl_phy	<= # dly 1'b0;
				ampl_out_se2	<= # dly ampl_out;
				phase_out_se2	<= # dly phase_out;	
				done_iq			<= # dly 1'b1;
			end
			default: begin
				counter_iq		<= # dly 2'b0;
				start_ampl_phy	<= # dly 1'b0;
				done_iq			<= # dly 1'b0;			
			end	
		endcase
	end else begin
		start_ampl_phy	<= # dly 1'b0;
		done_iq			<= # dly 1'b0;			
	end
end

assign demod_phy_out	=  demod_phy[39:4];

cordic_ampl_phy cordic_de_rotator
	(.clk(clk),
	.clrn(clrn),
	.x_in(x_in_derot),
	.y_in(y_in_derot),
	.start(start_ampl_phy),
	.done(ampl_phy_done),
	.ampl_out(ampl_out),
	.phase_out(phase_out));
                                                                                            
endmodule