`timescale 1ns/1ns

module cordic_rotator_folded
	(input	clk,
	input 	clrn,
	input	[39:0] phase_in,
	input	[41:0] start_value,
	input 	start,
	output	done,
	output	[35:0] cos_out,
	output	[35:0] sin_out);

//parameter start_value	= 42'h136_e9db_5080;
	
parameter atan_0	= 38'h2000000000;   
parameter atan_1	= 38'h12e4051d9e;   
parameter atan_2	= 38'h09fb385b5f;   
parameter atan_3	= 38'h051111d41e;
parameter atan_4	= 38'h028b0d430e;   
parameter atan_5	= 38'h0145d7e159;   
parameter atan_6	= 38'h00a2f61e5c;   
parameter atan_7	= 38'h00517c5512;
parameter atan_8	= 38'h0028be5347;   
parameter atan_9	= 38'h00145f2ebb;   
parameter atan_10	= 38'h000a2f9801;   
parameter atan_11	= 38'h000517cc15;
parameter atan_12	= 38'h00028be60d;  
parameter atan_13	= 38'h000145f307;   
parameter atan_14	= 38'h0000a2f983;   
parameter atan_15	= 38'h0000517cc2;
parameter atan_16	= 38'h000028be61;   
parameter atan_17	= 38'h0000145f30;   
parameter atan_18	= 38'h00000a2f98;   
parameter atan_19	= 38'h00000517cc;
parameter atan_20	= 38'h0000028be6;   
parameter atan_21	= 38'h00000145f3;   
parameter atan_22	= 38'h000000a2fa;   
parameter atan_23	= 38'h000000517d;
parameter atan_24	= 38'h00000028be;   
parameter atan_25	= 38'h000000145f;   
parameter atan_26	= 38'h0000000a30;   
parameter atan_27	= 38'h0000000518;
parameter atan_28	= 38'h000000028c;   
parameter atan_29	= 38'h0000000146;   
parameter atan_30	= 38'h00000000a3;   
parameter atan_31	= 38'h0000000051;
parameter atan_32	= 38'h0000000029;   
parameter atan_33	= 38'h0000000014;   
parameter atan_34	= 38'h000000000a;   
parameter atan_35	= 38'h0000000005;		

wire [39:0] atan [35:0];

assign atan[ 0]	= {1'b0, atan_0 };
assign atan[ 1]	= {1'b0, atan_1 };
assign atan[ 2]	= {1'b0, atan_2 };
assign atan[ 3]	= {1'b0, atan_3 };
assign atan[ 4]	= {1'b0, atan_4 };
assign atan[ 5]	= {1'b0, atan_5 };
assign atan[ 6]	= {1'b0, atan_6 };
assign atan[ 7]	= {1'b0, atan_7 };
assign atan[ 8]	= {1'b0, atan_8 };
assign atan[ 9]	= {1'b0, atan_9 };
assign atan[10]	= {1'b0, atan_10};   
assign atan[11]	= {1'b0, atan_11};
assign atan[12]	= {1'b0, atan_12};  
assign atan[13]	= {1'b0, atan_13};   
assign atan[14]	= {1'b0, atan_14};   
assign atan[15]	= {1'b0, atan_15};
assign atan[16]	= {1'b0, atan_16};   
assign atan[17]	= {1'b0, atan_17};   
assign atan[18]	= {1'b0, atan_18};   
assign atan[19]	= {1'b0, atan_19};
assign atan[20]	= {1'b0, atan_20};   
assign atan[21]	= {1'b0, atan_21};   
assign atan[22]	= {1'b0, atan_22};   
assign atan[23]	= {1'b0, atan_23};
assign atan[24]	= {1'b0, atan_24};   
assign atan[25]	= {1'b0, atan_25};   
assign atan[26]	= {1'b0, atan_26};   
assign atan[27]	= {1'b0, atan_27};
assign atan[28]	= {1'b0, atan_28};   
assign atan[29]	= {1'b0, atan_29};   
assign atan[30]	= {1'b0, atan_30};   
assign atan[31]	= {1'b0, atan_31};
assign atan[32]	= {1'b0, atan_32};   
assign atan[33]	= {1'b0, atan_33};   
assign atan[34]	= {1'b0, atan_34};   
assign atan[35]	= {1'b0, atan_35};


parameter dly=1;


reg [41:0] pre_sin; //output precision + log2(output precision)
reg [41:0] pre_cos;
reg [38:0] phase_acc;

reg	[5:0] counter;

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin 
		counter	<= # dly 6'd35;
	end else if (start) begin
		counter	<= # dly 6'd1;
	end else if (counter!=6'd36) begin
		counter	<= # dly counter + 1'b1;
	end   
end

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin
		phase_acc	<= # dly 39'd0;
		pre_cos		<= # dly 42'd0;
		pre_sin		<= # dly 42'd0;
	end else if (start) begin
		phase_acc	<= # dly phase_in[38] ? phase_in[38:0]+atan[0] : phase_in[38:0]-atan[0];
		pre_cos		<= # dly ^phase_in[39:38] ? -start_value : start_value;
		pre_sin		<= # dly phase_in[39] ? -start_value : start_value;
	end else case (counter)
		6'd1: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[1] : phase_acc - atan[1];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{1{pre_sin[41]}}, pre_sin[41:1]} : pre_cos - {{1{pre_sin[41]}}, pre_sin[41:1]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{1{pre_cos[41]}}, pre_cos[41:1]} : pre_sin + {{1{pre_cos[41]}}, pre_cos[41:1]};
		end
		
		6'd2: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[2] : phase_acc - atan[2];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{2{pre_sin[41]}}, pre_sin[41:2]} : pre_cos - {{2{pre_sin[41]}}, pre_sin[41:2]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{2{pre_cos[41]}}, pre_cos[41:2]} : pre_sin + {{2{pre_cos[41]}}, pre_cos[41:2]};
		end
		
		6'd3: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[3] : phase_acc - atan[3];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{3{pre_sin[41]}}, pre_sin[41:3]} : pre_cos - {{3{pre_sin[41]}}, pre_sin[41:3]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{3{pre_cos[41]}}, pre_cos[41:3]} : pre_sin + {{3{pre_cos[41]}}, pre_cos[41:3]};
		end
		
		6'd4: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[4] : phase_acc - atan[4];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{4{pre_sin[41]}}, pre_sin[41:4]} : pre_cos - {{4{pre_sin[41]}}, pre_sin[41:4]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{4{pre_cos[41]}}, pre_cos[41:4]} : pre_sin + {{4{pre_cos[41]}}, pre_cos[41:4]};
		end
		
		6'd5: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[5] : phase_acc - atan[5];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{5{pre_sin[41]}}, pre_sin[41:5]} : pre_cos - {{5{pre_sin[41]}}, pre_sin[41:5]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{5{pre_cos[41]}}, pre_cos[41:5]} : pre_sin + {{5{pre_cos[41]}}, pre_cos[41:5]};
		end
		
		6'd6: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[6] : phase_acc - atan[6];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{6{pre_sin[41]}}, pre_sin[41:6]} : pre_cos - {{6{pre_sin[41]}}, pre_sin[41:6]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{6{pre_cos[41]}}, pre_cos[41:6]} : pre_sin + {{6{pre_cos[41]}}, pre_cos[41:6]};
		end
		
		6'd7: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[7] : phase_acc - atan[7];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{7{pre_sin[41]}}, pre_sin[41:7]} : pre_cos - {{7{pre_sin[41]}}, pre_sin[41:7]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{7{pre_cos[41]}}, pre_cos[41:7]} : pre_sin + {{7{pre_cos[41]}}, pre_cos[41:7]};
		end
		
		6'd8: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[8] : phase_acc - atan[8];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{8{pre_sin[41]}}, pre_sin[41:8]} : pre_cos - {{8{pre_sin[41]}}, pre_sin[41:8]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{8{pre_cos[41]}}, pre_cos[41:8]} : pre_sin + {{8{pre_cos[41]}}, pre_cos[41:8]};
		end
		
		6'd9: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[9] : phase_acc - atan[9];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{9{pre_sin[41]}}, pre_sin[41:9]} : pre_cos - {{9{pre_sin[41]}}, pre_sin[41:9]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{9{pre_cos[41]}}, pre_cos[41:9]} : pre_sin + {{9{pre_cos[41]}}, pre_cos[41:9]};
		end
		
		6'd10: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[10] : phase_acc - atan[10];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{10{pre_sin[41]}}, pre_sin[41:10]} : pre_cos - {{10{pre_sin[41]}}, pre_sin[41:10]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{10{pre_cos[41]}}, pre_cos[41:10]} : pre_sin + {{10{pre_cos[41]}}, pre_cos[41:10]};
		end
		
		6'd11: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[11] : phase_acc - atan[11];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{11{pre_sin[41]}}, pre_sin[41:11]} : pre_cos - {{11{pre_sin[41]}}, pre_sin[41:11]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{11{pre_cos[41]}}, pre_cos[41:11]} : pre_sin + {{11{pre_cos[41]}}, pre_cos[41:11]};
		end
		
		6'd12: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[12] : phase_acc - atan[12];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{12{pre_sin[41]}}, pre_sin[41:12]} : pre_cos - {{12{pre_sin[41]}}, pre_sin[41:12]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{12{pre_cos[41]}}, pre_cos[41:12]} : pre_sin + {{12{pre_cos[41]}}, pre_cos[41:12]};
		end
		
		6'd13: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[13] : phase_acc - atan[13];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{13{pre_sin[41]}}, pre_sin[41:13]} : pre_cos - {{13{pre_sin[41]}}, pre_sin[41:13]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{13{pre_cos[41]}}, pre_cos[41:13]} : pre_sin + {{13{pre_cos[41]}}, pre_cos[41:13]};
		end
		
		6'd14: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[14] : phase_acc - atan[14];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{14{pre_sin[41]}}, pre_sin[41:14]} : pre_cos - {{14{pre_sin[41]}}, pre_sin[41:14]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{14{pre_cos[41]}}, pre_cos[41:14]} : pre_sin + {{14{pre_cos[41]}}, pre_cos[41:14]};
		end
		
		6'd15: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[15] : phase_acc - atan[15];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{15{pre_sin[41]}}, pre_sin[41:15]} : pre_cos - {{15{pre_sin[41]}}, pre_sin[41:15]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{15{pre_cos[41]}}, pre_cos[41:15]} : pre_sin + {{15{pre_cos[41]}}, pre_cos[41:15]};
		end
		
		6'd16: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[16] : phase_acc - atan[16];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{16{pre_sin[41]}}, pre_sin[41:16]} : pre_cos - {{16{pre_sin[41]}}, pre_sin[41:16]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{16{pre_cos[41]}}, pre_cos[41:16]} : pre_sin + {{16{pre_cos[41]}}, pre_cos[41:16]};
		end
		
		6'd17: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[17] : phase_acc - atan[17];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{17{pre_sin[41]}}, pre_sin[41:17]} : pre_cos - {{17{pre_sin[41]}}, pre_sin[41:17]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{17{pre_cos[41]}}, pre_cos[41:17]} : pre_sin + {{17{pre_cos[41]}}, pre_cos[41:17]};
		end
		
		6'd18: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[18] : phase_acc - atan[18];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{18{pre_sin[41]}}, pre_sin[41:18]} : pre_cos - {{18{pre_sin[41]}}, pre_sin[41:18]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{18{pre_cos[41]}}, pre_cos[41:18]} : pre_sin + {{18{pre_cos[41]}}, pre_cos[41:18]};
		end
		
		6'd19: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[19] : phase_acc - atan[19];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{19{pre_sin[41]}}, pre_sin[41:19]} : pre_cos - {{19{pre_sin[41]}}, pre_sin[41:19]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{19{pre_cos[41]}}, pre_cos[41:19]} : pre_sin + {{19{pre_cos[41]}}, pre_cos[41:19]};
		end
		
		6'd20: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[20] : phase_acc - atan[20];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{20{pre_sin[41]}}, pre_sin[41:20]} : pre_cos - {{20{pre_sin[41]}}, pre_sin[41:20]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{20{pre_cos[41]}}, pre_cos[41:20]} : pre_sin + {{20{pre_cos[41]}}, pre_cos[41:20]};
		end
		
		6'd21: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[21] : phase_acc - atan[21];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{21{pre_sin[41]}}, pre_sin[41:21]} : pre_cos - {{21{pre_sin[41]}}, pre_sin[41:21]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{21{pre_cos[41]}}, pre_cos[41:21]} : pre_sin + {{21{pre_cos[41]}}, pre_cos[41:21]};
		end
		
		6'd22: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[22] : phase_acc - atan[22];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{22{pre_sin[41]}}, pre_sin[41:22]} : pre_cos - {{22{pre_sin[41]}}, pre_sin[41:22]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{22{pre_cos[41]}}, pre_cos[41:22]} : pre_sin + {{22{pre_cos[41]}}, pre_cos[41:22]};
		end
		
		6'd23: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[23] : phase_acc - atan[23];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{23{pre_sin[41]}}, pre_sin[41:23]} : pre_cos - {{23{pre_sin[41]}}, pre_sin[41:23]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{23{pre_cos[41]}}, pre_cos[41:23]} : pre_sin + {{23{pre_cos[41]}}, pre_cos[41:23]};
		end
		
		6'd24: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[24] : phase_acc - atan[24];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{24{pre_sin[41]}}, pre_sin[41:24]} : pre_cos - {{24{pre_sin[41]}}, pre_sin[41:24]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{24{pre_cos[41]}}, pre_cos[41:24]} : pre_sin + {{24{pre_cos[41]}}, pre_cos[41:24]};
		end
		
		6'd25: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[25] : phase_acc - atan[25];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{25{pre_sin[41]}}, pre_sin[41:25]} : pre_cos - {{25{pre_sin[41]}}, pre_sin[41:25]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{25{pre_cos[41]}}, pre_cos[41:25]} : pre_sin + {{25{pre_cos[41]}}, pre_cos[41:25]};
		end
		
		6'd26: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[26] : phase_acc - atan[26];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{26{pre_sin[41]}}, pre_sin[41:26]} : pre_cos - {{26{pre_sin[41]}}, pre_sin[41:26]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{26{pre_cos[41]}}, pre_cos[41:26]} : pre_sin + {{26{pre_cos[41]}}, pre_cos[41:26]};
		end
		
		6'd27: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[27] : phase_acc - atan[27];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{27{pre_sin[41]}}, pre_sin[41:27]} : pre_cos - {{27{pre_sin[41]}}, pre_sin[41:27]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{27{pre_cos[41]}}, pre_cos[41:27]} : pre_sin + {{27{pre_cos[41]}}, pre_cos[41:27]};
		end
		
		6'd28: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[28] : phase_acc - atan[28];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{28{pre_sin[41]}}, pre_sin[41:28]} : pre_cos - {{28{pre_sin[41]}}, pre_sin[41:28]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{28{pre_cos[41]}}, pre_cos[41:28]} : pre_sin + {{28{pre_cos[41]}}, pre_cos[41:28]};
		end
		
		6'd29: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[29] : phase_acc - atan[29];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{29{pre_sin[41]}}, pre_sin[41:29]} : pre_cos - {{29{pre_sin[41]}}, pre_sin[41:29]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{29{pre_cos[41]}}, pre_cos[41:29]} : pre_sin + {{29{pre_cos[41]}}, pre_cos[41:29]};
		end
		
		6'd30: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[30] : phase_acc - atan[30];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{30{pre_sin[41]}}, pre_sin[41:30]} : pre_cos - {{30{pre_sin[41]}}, pre_sin[41:30]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{30{pre_cos[41]}}, pre_cos[41:30]} : pre_sin + {{30{pre_cos[41]}}, pre_cos[41:30]};
		end
		
		6'd31: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[31] : phase_acc - atan[31];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{31{pre_sin[41]}}, pre_sin[41:31]} : pre_cos - {{31{pre_sin[41]}}, pre_sin[41:31]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{31{pre_cos[41]}}, pre_cos[41:31]} : pre_sin + {{31{pre_cos[41]}}, pre_cos[41:31]};
		end
		
		6'd32: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[32] : phase_acc - atan[32];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{32{pre_sin[41]}}, pre_sin[41:32]} : pre_cos - {{32{pre_sin[41]}}, pre_sin[41:32]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{32{pre_cos[41]}}, pre_cos[41:32]} : pre_sin + {{32{pre_cos[41]}}, pre_cos[41:32]};
		end
		
		6'd33: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[33] : phase_acc - atan[33];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{33{pre_sin[41]}}, pre_sin[41:33]} : pre_cos - {{33{pre_sin[41]}}, pre_sin[41:33]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{33{pre_cos[41]}}, pre_cos[41:33]} : pre_sin + {{33{pre_cos[41]}}, pre_cos[41:33]};
		end
		
		6'd34: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[34] : phase_acc - atan[34];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{34{pre_sin[41]}}, pre_sin[41:34]} : pre_cos - {{34{pre_sin[41]}}, pre_sin[41:34]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{34{pre_cos[41]}}, pre_cos[41:34]} : pre_sin + {{34{pre_cos[41]}}, pre_cos[41:34]};
		end
		
		6'd35: begin
			phase_acc	<= # dly phase_acc[38] ? phase_acc + atan[35] : phase_acc - atan[35];
			pre_cos		<= # dly phase_acc[38] ? pre_cos + {{35{pre_sin[41]}}, pre_sin[41:35]} : pre_cos - {{35{pre_sin[41]}}, pre_sin[41:35]};
			pre_sin		<= # dly phase_acc[38] ? pre_sin - {{35{pre_cos[41]}}, pre_cos[41:35]} : pre_sin + {{35{pre_cos[41]}}, pre_cos[41:35]};
		end
		default: begin
		
		end
	endcase
end

assign cos_out	= pre_cos[41:6];
assign sin_out	= pre_sin[41:6];
assign done		= counter==6'd36;
					
	

endmodule