`timescale 1ns/1ns

module cordic_rotator_unfolded
	(input	clk,
	input	[41:0] amplitude,
	input	[39:0] phase_in,
	output	[35:0] cos_out,
	output	[35:0] sin_out);
	
parameter atan_0	= 38'h2000000000;   
parameter atan_1	= 38'h12e4051d9e;   
parameter atan_2	= 38'h09fb385b5f;   
parameter atan_3	= 38'h051111d41e;
parameter atan_4	= 38'h028b0d430e;   
parameter atan_5	= 38'h0145d7e159;   
parameter atan_6	= 38'h00a2f61e5c;   
parameter atan_7	= 38'h00517c5512;
parameter atan_8	= 38'h0028be5347;   
parameter atan_9	= 38'h00145f2ebb;   
parameter atan_10	= 38'h000a2f9801;   
parameter atan_11	= 38'h000517cc15;
parameter atan_12	= 38'h00028be60d;  
parameter atan_13	= 38'h000145f307;   
parameter atan_14	= 38'h0000a2f983;   
parameter atan_15	= 38'h0000517cc2;
parameter atan_16	= 38'h000028be61;   
parameter atan_17	= 38'h0000145f30;   
parameter atan_18	= 38'h00000a2f98;   
parameter atan_19	= 38'h00000517cc;
parameter atan_20	= 38'h0000028be6;   
parameter atan_21	= 38'h00000145f3;   
parameter atan_22	= 38'h000000a2fa;   
parameter atan_23	= 38'h000000517d;
parameter atan_24	= 38'h00000028be;   
parameter atan_25	= 38'h000000145f;   
parameter atan_26	= 38'h0000000a30;   
parameter atan_27	= 38'h0000000518;
parameter atan_28	= 38'h000000028c;   
parameter atan_29	= 38'h0000000146;   
parameter atan_30	= 38'h00000000a3;   
parameter atan_31	= 38'h0000000051;
parameter atan_32	= 38'h0000000029;   
parameter atan_33	= 38'h0000000014;   
parameter atan_34	= 38'h000000000a;   
parameter atan_35	= 38'h0000000005;		

wire [39:0] atan [35:0];

assign atan[ 0]	= {1'b0, atan_0 };
assign atan[ 1]	= {1'b0, atan_1 };
assign atan[ 2]	= {1'b0, atan_2 };
assign atan[ 3]	= {1'b0, atan_3 };
assign atan[ 4]	= {1'b0, atan_4 };
assign atan[ 5]	= {1'b0, atan_5 };
assign atan[ 6]	= {1'b0, atan_6 };
assign atan[ 7]	= {1'b0, atan_7 };
assign atan[ 8]	= {1'b0, atan_8 };
assign atan[ 9]	= {1'b0, atan_9 };
assign atan[10]	= {1'b0, atan_10};   
assign atan[11]	= {1'b0, atan_11};
assign atan[12]	= {1'b0, atan_12};  
assign atan[13]	= {1'b0, atan_13};   
assign atan[14]	= {1'b0, atan_14};   
assign atan[15]	= {1'b0, atan_15};
assign atan[16]	= {1'b0, atan_16};   
assign atan[17]	= {1'b0, atan_17};   
assign atan[18]	= {1'b0, atan_18};   
assign atan[19]	= {1'b0, atan_19};
assign atan[20]	= {1'b0, atan_20};   
assign atan[21]	= {1'b0, atan_21};   
assign atan[22]	= {1'b0, atan_22};   
assign atan[23]	= {1'b0, atan_23};
assign atan[24]	= {1'b0, atan_24};   
assign atan[25]	= {1'b0, atan_25};   
assign atan[26]	= {1'b0, atan_26};   
assign atan[27]	= {1'b0, atan_27};
assign atan[28]	= {1'b0, atan_28};   
assign atan[29]	= {1'b0, atan_29};   
assign atan[30]	= {1'b0, atan_30};   
assign atan[31]	= {1'b0, atan_31};
assign atan[32]	= {1'b0, atan_32};   
assign atan[33]	= {1'b0, atan_33};   
assign atan[34]	= {1'b0, atan_34};   
assign atan[35]	= {1'b0, atan_35};


parameter dly=1;


reg [41:0] pre_sin [35:0]; //output precision + log2(output precision)
reg [41:0] pre_cos [35:0];
reg [38:0] phase_acc [35:0];

always @(posedge clk) begin
	phase_acc[0]	<= # dly phase_in[38] ? phase_in[38:0]+atan[0] : phase_in[38:0]-atan[0];
	pre_cos[0]		<= # dly ^phase_in[39:38] ? -amplitude : amplitude;
	pre_sin[0]		<= # dly phase_in[39] ? -amplitude : amplitude;
end	
	
always @(posedge clk) begin
	phase_acc[1]	<= # dly phase_acc[0][38] ? phase_acc[0] + atan[1] : phase_acc[0] - atan[1];
	pre_cos[1]		<= # dly phase_acc[0][38] ? pre_cos[0] + {{1{pre_sin[0][41]}}, pre_sin[0][41:1]} : pre_cos[0] - {{1{pre_sin[0][41]}}, pre_sin[0][41:1]};
	pre_sin[1]		<= # dly phase_acc[0][38] ? pre_sin[0] - {{1{pre_cos[0][41]}}, pre_cos[0][41:1]} : pre_sin[0] + {{1{pre_cos[0][41]}}, pre_cos[0][41:1]};
end	

always@(posedge clk) begin
	phase_acc[2]	<= # dly phase_acc[1][38] ? phase_acc[1] + atan[2] : phase_acc[1] - atan[2];
	pre_cos[2]		<= # dly phase_acc[1][38] ? pre_cos[1] + {{ 2{pre_sin[1][41]}}, pre_sin[1][41: 2]} : pre_cos[1] - {{ 2{pre_sin[1][41]}}, pre_sin[1][41:2]};
	pre_sin[2]		<= # dly phase_acc[1][38] ? pre_sin[1] - {{ 2{pre_cos[1][41]}}, pre_cos[1][41: 2]} : pre_sin[1] + {{ 2{pre_cos[1][41]}}, pre_cos[1][41:2]};
end

always@(posedge clk) begin
	phase_acc[3]	<= # dly phase_acc[2][38] ? phase_acc[2] + atan[3] : phase_acc[2] - atan[3];
	pre_cos[3]		<= # dly phase_acc[2][38] ? pre_cos[ 2] + {{3{pre_sin[2][41]}}, pre_sin[2][41:3]} : pre_cos[2] - {{3{pre_sin[2][41]}}, pre_sin[2][41:3]};
	pre_sin[3]		<= # dly phase_acc[2][38] ? pre_sin[ 2] - {{3{pre_cos[2][41]}}, pre_cos[2][41:3]} : pre_sin[2] + {{3{pre_cos[2][41]}}, pre_cos[2][41:3]};
end

always@(posedge clk) begin
	phase_acc[4]	<= # dly phase_acc[3][38] ? phase_acc[3] + atan[4] : phase_acc[3] - atan[4];
	pre_cos[4]		<= # dly phase_acc[3][38] ? pre_cos[3] + {{4{pre_sin[3][41]}}, pre_sin[3][41:4]} : pre_cos[3] - {{4{pre_sin[3][41]}}, pre_sin[3][41:4]};
	pre_sin[4]		<= # dly phase_acc[3][38] ? pre_sin[3] - {{4{pre_cos[3][41]}}, pre_cos[3][41:4]} : pre_sin[3] + {{4{pre_cos[3][41]}}, pre_cos[3][41:4]};
end

always@(posedge clk) begin
	phase_acc[5]	<= # dly phase_acc[4][38] ? phase_acc[4] + atan[5] : phase_acc[4] - atan[5];
	pre_cos[5]		<= # dly phase_acc[4][38] ? pre_cos[4] + {{5{pre_sin[4][41]}}, pre_sin[4][41:5]} : pre_cos[4] - {{5{pre_sin[4][41]}}, pre_sin[4][41:5]};
	pre_sin[5]		<= # dly phase_acc[4][38] ? pre_sin[4] - {{5{pre_cos[4][41]}}, pre_cos[4][41:5]} : pre_sin[4] + {{5{pre_cos[4][41]}}, pre_cos[4][41:5]};
end

always@(posedge clk) begin
	phase_acc[6]	<= # dly phase_acc[5][38] ? phase_acc[5] + atan[6] : phase_acc[5] - atan[6];
	pre_cos[6]		<= # dly phase_acc[5][38] ? pre_cos[5] + {{ 6{pre_sin[5][41]}}, pre_sin[5][41:6]} : pre_cos[5] - {{6{pre_sin[5][41]}}, pre_sin[5][41:6]};
	pre_sin[6]		<= # dly phase_acc[5][38] ? pre_sin[5] - {{ 6{pre_cos[5][41]}}, pre_cos[5][41:6]} : pre_sin[5] + {{6{pre_cos[5][41]}}, pre_cos[5][41:6]};
end

always@(posedge clk) begin
	phase_acc[7]	<= # dly phase_acc[6][38] ? phase_acc[6] + atan[7] : phase_acc[6] - atan[7];
	pre_cos[7]		<= # dly phase_acc[6][38] ? pre_cos[6] + {{7{pre_sin[6][41]}}, pre_sin[6][41:7]} : pre_cos[6] - {{7{pre_sin[6][41]}}, pre_sin[6][41:7]};
	pre_sin[7]		<= # dly phase_acc[6][38] ? pre_sin[6] - {{7{pre_cos[6][41]}}, pre_cos[6][41:7]} : pre_sin[6] + {{7{pre_cos[6][41]}}, pre_cos[6][41:7]};
end

always@(posedge clk) begin
	phase_acc[8]	<= # dly phase_acc[7][38] ? phase_acc[7] + atan[ 8] : phase_acc[7] - atan[ 8];
	pre_cos[8]		<= # dly phase_acc[7][38] ? pre_cos[7] + {{ 8{pre_sin[7][41]}}, pre_sin[7][41:8]} : pre_cos[7] - {{8{pre_sin[7][41]}}, pre_sin[7][41:8]};
	pre_sin[8]		<= # dly phase_acc[7][38] ? pre_sin[7] - {{ 8{pre_cos[7][41]}}, pre_cos[7][41:8]} : pre_sin[7] + {{8{pre_cos[7][41]}}, pre_cos[7][41:8]};
end

always@(posedge clk) begin
	phase_acc[9]	<= # dly phase_acc[8][38] ? phase_acc[8] + atan[9] : phase_acc[8] - atan[9];
	pre_cos[9]		<= # dly phase_acc[8][38] ? pre_cos[8] + {{9{pre_sin[8][41]}}, pre_sin[8][41: 9]} : pre_cos[8] - {{9{pre_sin[8][41]}}, pre_sin[8][41:9]};
	pre_sin[9]		<= # dly phase_acc[8][38] ? pre_sin[8] - {{9{pre_cos[8][41]}}, pre_cos[8][41: 9]} : pre_sin[8] + {{9{pre_cos[8][41]}}, pre_cos[8][41:9]};
end

always@(posedge clk) begin
	phase_acc[10]	<= # dly phase_acc[9][38] ? phase_acc[ 9] + atan[10] : phase_acc[ 9] - atan[10];
	pre_cos[10]		<= # dly phase_acc[9][38] ? pre_cos[ 9] + {{10{pre_sin[ 9][41]}}, pre_sin[ 9][41:10]} : pre_cos[ 9] - {{10{pre_sin[ 9][41]}}, pre_sin[ 9][41:10]};
	pre_sin[10]		<= # dly phase_acc[9][38] ? pre_sin[ 9] - {{10{pre_cos[ 9][41]}}, pre_cos[ 9][41:10]} : pre_sin[ 9] + {{10{pre_cos[ 9][41]}}, pre_cos[ 9][41:10]};
end

always@(posedge clk) begin
	phase_acc[11]	<= # dly phase_acc[10][38] ? phase_acc[10] + atan[11] : phase_acc[10] - atan[11];
	pre_cos[11]		<= # dly phase_acc[10][38] ? pre_cos[10] + {{11{pre_sin[10][41]}}, pre_sin[10][41:11]} : pre_cos[10] - {{11{pre_sin[10][41]}}, pre_sin[10][41:11]};
	pre_sin[11]		<= # dly phase_acc[10][38] ? pre_sin[10] - {{11{pre_cos[10][41]}}, pre_cos[10][41:11]} : pre_sin[10] + {{11{pre_cos[10][41]}}, pre_cos[10][41:11]};
end

always@(posedge clk) begin
	phase_acc[12]	<= # dly phase_acc[11][38] ? phase_acc[11] + atan[12] : phase_acc[11] - atan[12];
	pre_cos[12]		<= # dly phase_acc[11][38] ? pre_cos[11] + {{12{pre_sin[11][41]}}, pre_sin[11][41:12]} : pre_cos[11] - {{12{pre_sin[11][41]}}, pre_sin[11][41:12]};
	pre_sin[12]		<= # dly phase_acc[11][38] ? pre_sin[11] - {{12{pre_cos[11][41]}}, pre_cos[11][41:12]} : pre_sin[11] + {{12{pre_cos[11][41]}}, pre_cos[11][41:12]};
end

always@(posedge clk) begin
	phase_acc[13]	<= # dly phase_acc[12][38] ? phase_acc[12] + atan[13] : phase_acc[12] - atan[13];
	pre_cos[13]		<= # dly phase_acc[12][38] ? pre_cos[12] + {{13{pre_sin[12][41]}}, pre_sin[12][41:13]} : pre_cos[12] - {{13{pre_sin[12][41]}}, pre_sin[12][41:13]};
	pre_sin[13]		<= # dly phase_acc[12][38] ? pre_sin[12] - {{13{pre_cos[12][41]}}, pre_cos[12][41:13]} : pre_sin[12] + {{13{pre_cos[12][41]}}, pre_cos[12][41:13]};
end

always@(posedge clk) begin
	phase_acc[14]	<= # dly phase_acc[13][38] ? phase_acc[13] + atan[14] : phase_acc[13] - atan[14];
	pre_cos[14]		<= # dly phase_acc[13][38] ? pre_cos[13] + {{14{pre_sin[13][41]}}, pre_sin[13][41:14]} : pre_cos[13] - {{14{pre_sin[13][41]}}, pre_sin[13][41:14]};
	pre_sin[14]		<= # dly phase_acc[13][38] ? pre_sin[13] - {{14{pre_cos[13][41]}}, pre_cos[13][41:14]} : pre_sin[13] + {{14{pre_cos[13][41]}}, pre_cos[13][41:14]};
end

always@(posedge clk) begin
	phase_acc[15]	<= # dly phase_acc[14][38] ? phase_acc[14] + atan[15] : phase_acc[14] - atan[15];
	pre_cos[15]		<= # dly phase_acc[14][38] ? pre_cos[14] + {{15{pre_sin[14][41]}}, pre_sin[14][41:15]} : pre_cos[14] - {{15{pre_sin[14][41]}}, pre_sin[14][41:15]};
	pre_sin[15]		<= # dly phase_acc[14][38] ? pre_sin[14] - {{15{pre_cos[14][41]}}, pre_cos[14][41:15]} : pre_sin[14] + {{15{pre_cos[14][41]}}, pre_cos[14][41:15]};
end

always@(posedge clk) begin
	phase_acc[16]	<= # dly phase_acc[15][38] ? phase_acc[15] + atan[16] : phase_acc[15] - atan[16];
	pre_cos[16]		<= # dly phase_acc[15][38] ? pre_cos[15] + {{16{pre_sin[15][41]}}, pre_sin[15][41:16]} : pre_cos[15] - {{16{pre_sin[15][41]}}, pre_sin[15][41:16]};
	pre_sin[16]		<= # dly phase_acc[15][38] ? pre_sin[15] - {{16{pre_cos[15][41]}}, pre_cos[15][41:16]} : pre_sin[15] + {{16{pre_cos[15][41]}}, pre_cos[15][41:16]};
end

always@(posedge clk) begin
	phase_acc[17]	<= # dly phase_acc[16][38] ? phase_acc[16] + atan[17] : phase_acc[16] - atan[17];
	pre_cos[17]		<= # dly phase_acc[16][38] ? pre_cos[16] + {{17{pre_sin[16][41]}}, pre_sin[16][41:17]} : pre_cos[16] - {{17{pre_sin[16][41]}}, pre_sin[16][41:17]};
	pre_sin[17]		<= # dly phase_acc[16][38] ? pre_sin[16] - {{17{pre_cos[16][41]}}, pre_cos[16][41:17]} : pre_sin[16] + {{17{pre_cos[16][41]}}, pre_cos[16][41:17]};
end

always@(posedge clk) begin
	phase_acc[18]	<= # dly phase_acc[17][38] ? phase_acc[17] + atan[18] : phase_acc[17] - atan[18];
	pre_cos[18]		<= # dly phase_acc[17][38] ? pre_cos[17] + {{18{pre_sin[17][41]}}, pre_sin[17][41:18]} : pre_cos[17] - {{18{pre_sin[17][41]}}, pre_sin[17][41:18]};
	pre_sin[18]		<= # dly phase_acc[17][38] ? pre_sin[17] - {{18{pre_cos[17][41]}}, pre_cos[17][41:18]} : pre_sin[17] + {{18{pre_cos[17][41]}}, pre_cos[17][41:18]};
end

always@(posedge clk) begin
	phase_acc[19]	<= # dly phase_acc[18][38] ? phase_acc[18] + atan[19] : phase_acc[18] - atan[19];
	pre_cos[19]		<= # dly phase_acc[18][38] ? pre_cos[18] + {{19{pre_sin[18][41]}}, pre_sin[18][41:19]} : pre_cos[18] - {{19{pre_sin[18][41]}}, pre_sin[18][41:19]};
	pre_sin[19]		<= # dly phase_acc[18][38] ? pre_sin[18] - {{19{pre_cos[18][41]}}, pre_cos[18][41:19]} : pre_sin[18] + {{19{pre_cos[18][41]}}, pre_cos[18][41:19]};
end

always@(posedge clk) begin
	phase_acc[20]	<= # dly phase_acc[19][38] ? phase_acc[19] + atan[20] : phase_acc[19] - atan[20];
	pre_cos[20]		<= # dly phase_acc[19][38] ? pre_cos[19] + {{20{pre_sin[19][41]}}, pre_sin[19][41:20]} : pre_cos[19] - {{20{pre_sin[19][41]}}, pre_sin[19][41:20]};
	pre_sin[20]		<= # dly phase_acc[19][38] ? pre_sin[19] - {{20{pre_cos[19][41]}}, pre_cos[19][41:20]} : pre_sin[19] + {{20{pre_cos[19][41]}}, pre_cos[19][41:20]};
end

always@(posedge clk) begin
	phase_acc[21]	<= # dly phase_acc[20][38] ? phase_acc[20] + atan[21] : phase_acc[20] - atan[21];
	pre_cos[21]		<= # dly phase_acc[20][38] ? pre_cos[20] + {{21{pre_sin[20][41]}}, pre_sin[20][41:21]} : pre_cos[20] - {{21{pre_sin[20][41]}}, pre_sin[20][41:21]};
	pre_sin[21]		<= # dly phase_acc[20][38] ? pre_sin[20] - {{21{pre_cos[20][41]}}, pre_cos[20][41:21]} : pre_sin[20] + {{21{pre_cos[20][41]}}, pre_cos[20][41:21]};
end

always@(posedge clk) begin
	phase_acc[22]	<= # dly phase_acc[21][38] ? phase_acc[21] + atan[22] : phase_acc[21] - atan[22];
	pre_cos[22]		<= # dly phase_acc[21][38] ? pre_cos[21] + {{22{pre_sin[21][41]}}, pre_sin[21][41:22]} : pre_cos[21] - {{22{pre_sin[21][41]}}, pre_sin[21][41:22]};
	pre_sin[22]		<= # dly phase_acc[21][38] ? pre_sin[21] - {{22{pre_cos[21][41]}}, pre_cos[21][41:22]} : pre_sin[21] + {{22{pre_cos[21][41]}}, pre_cos[21][41:22]};
end

always@(posedge clk) begin
	phase_acc[23]	<= # dly phase_acc[22][38] ? phase_acc[22] + atan[23] : phase_acc[22] - atan[23];
	pre_cos[23]		<= # dly phase_acc[22][38] ? pre_cos[22] + {{23{pre_sin[22][41]}}, pre_sin[22][41:23]} : pre_cos[22] - {{23{pre_sin[22][41]}}, pre_sin[22][41:23]};
	pre_sin[23]		<= # dly phase_acc[22][38] ? pre_sin[22] - {{23{pre_cos[22][41]}}, pre_cos[22][41:23]} : pre_sin[22] + {{23{pre_cos[22][41]}}, pre_cos[22][41:23]};
end

always@(posedge clk) begin
	phase_acc[24]	<= # dly phase_acc[23][38] ? phase_acc[23] + atan[24] : phase_acc[23] - atan[24];
	pre_cos[24]		<= # dly phase_acc[23][38] ? pre_cos[23] + {{24{pre_sin[23][41]}}, pre_sin[23][41:24]} : pre_cos[23] - {{24{pre_sin[23][41]}}, pre_sin[23][41:24]};
	pre_sin[24]		<= # dly phase_acc[23][38] ? pre_sin[23] - {{24{pre_cos[23][41]}}, pre_cos[23][41:24]} : pre_sin[23] + {{24{pre_cos[23][41]}}, pre_cos[23][41:24]};
end

always@(posedge clk) begin
	phase_acc[25]	<= # dly phase_acc[24][38] ? phase_acc[24] + atan[25] : phase_acc[24] - atan[25];
	pre_cos[25]		<= # dly phase_acc[24][38] ? pre_cos[24] + {{25{pre_sin[24][41]}}, pre_sin[24][41:25]} : pre_cos[24] - {{25{pre_sin[24][41]}}, pre_sin[24][41:25]};
	pre_sin[25]		<= # dly phase_acc[24][38] ? pre_sin[24] - {{25{pre_cos[24][41]}}, pre_cos[24][41:25]} : pre_sin[24] + {{25{pre_cos[24][41]}}, pre_cos[24][41:25]};
end

always@(posedge clk) begin
	phase_acc[26]	<= # dly phase_acc[25][38] ? phase_acc[25] + atan[26] : phase_acc[25] - atan[26];
	pre_cos[26]		<= # dly phase_acc[25][38] ? pre_cos[25] + {{26{pre_sin[25][41]}}, pre_sin[25][41:26]} : pre_cos[25] - {{26{pre_sin[25][41]}}, pre_sin[25][41:26]};
	pre_sin[26]		<= # dly phase_acc[25][38] ? pre_sin[25] - {{26{pre_cos[25][41]}}, pre_cos[25][41:26]} : pre_sin[25] + {{26{pre_cos[25][41]}}, pre_cos[25][41:26]};
end

always@(posedge clk) begin
	phase_acc[27]	<= # dly phase_acc[26][38] ? phase_acc[26] + atan[27] : phase_acc[26] - atan[27];
	pre_cos[27]		<= # dly phase_acc[26][38] ? pre_cos[26] + {{27{pre_sin[26][41]}}, pre_sin[26][41:27]} : pre_cos[26] - {{27{pre_sin[26][41]}}, pre_sin[26][41:27]};
	pre_sin[27]		<= # dly phase_acc[26][38] ? pre_sin[26] - {{27{pre_cos[26][41]}}, pre_cos[26][41:27]} : pre_sin[26] + {{27{pre_cos[26][41]}}, pre_cos[26][41:27]};
end

always@(posedge clk) begin
	phase_acc[28]	<= # dly phase_acc[27][38] ? phase_acc[27] + atan[28] : phase_acc[27] - atan[28];
	pre_cos[28]		<= # dly phase_acc[27][38] ? pre_cos[27] + {{28{pre_sin[27][41]}}, pre_sin[27][41:28]} : pre_cos[27] - {{28{pre_sin[27][41]}}, pre_sin[27][41:28]};
	pre_sin[28]		<= # dly phase_acc[27][38] ? pre_sin[27] - {{28{pre_cos[27][41]}}, pre_cos[27][41:28]} : pre_sin[27] + {{28{pre_cos[27][41]}}, pre_cos[27][41:28]};
end

always@(posedge clk) begin
	phase_acc[29]	<= # dly phase_acc[28][38] ? phase_acc[28] + atan[29] : phase_acc[28] - atan[29];
	pre_cos[29]		<= # dly phase_acc[28][38] ? pre_cos[28] + {{29{pre_sin[28][41]}}, pre_sin[28][41:29]} : pre_cos[28] - {{29{pre_sin[28][41]}}, pre_sin[28][41:29]};
	pre_sin[29]		<= # dly phase_acc[28][38] ? pre_sin[28] - {{29{pre_cos[28][41]}}, pre_cos[28][41:29]} : pre_sin[28] + {{29{pre_cos[28][41]}}, pre_cos[28][41:29]};
end

always@(posedge clk) begin
	phase_acc[30]	<= # dly phase_acc[29][38] ? phase_acc[29] + atan[30] : phase_acc[29] - atan[30];
	pre_cos[30]		<= # dly phase_acc[29][38] ? pre_cos[29] + {{30{pre_sin[29][41]}}, pre_sin[29][41:30]} : pre_cos[29] - {{30{pre_sin[29][41]}}, pre_sin[29][41:30]};
	pre_sin[30]		<= # dly phase_acc[29][38] ? pre_sin[29] - {{30{pre_cos[29][41]}}, pre_cos[29][41:30]} : pre_sin[29] + {{30{pre_cos[29][41]}}, pre_cos[29][41:30]};
end

always@(posedge clk) begin
	phase_acc[31]	<= # dly phase_acc[30][38] ? phase_acc[30] + atan[31] : phase_acc[30] - atan[31];
	pre_cos[31]		<= # dly phase_acc[30][38] ? pre_cos[30] + {{31{pre_sin[30][41]}}, pre_sin[30][41:31]} : pre_cos[30] - {{31{pre_sin[30][41]}}, pre_sin[30][41:31]};
	pre_sin[31]		<= # dly phase_acc[30][38] ? pre_sin[30] - {{31{pre_cos[30][41]}}, pre_cos[30][41:31]} : pre_sin[30] + {{31{pre_cos[30][41]}}, pre_cos[30][41:31]};
end

always@(posedge clk) begin
	phase_acc[32]	<= # dly phase_acc[31][38] ? phase_acc[31] + atan[32] : phase_acc[31] - atan[32];
	pre_cos[32]		<= # dly phase_acc[31][38] ? pre_cos[31] + {{32{pre_sin[31][41]}}, pre_sin[31][41:32]} : pre_cos[31] - {{32{pre_sin[31][41]}}, pre_sin[31][41:32]};
	pre_sin[32]		<= # dly phase_acc[31][38] ? pre_sin[31] - {{32{pre_cos[31][41]}}, pre_cos[31][41:32]} : pre_sin[31] + {{32{pre_cos[31][41]}}, pre_cos[31][41:32]};
end

always@(posedge clk) begin
	phase_acc[33]	<= # dly phase_acc[32][38] ? phase_acc[32] + atan[33] : phase_acc[32] - atan[33];
	pre_cos[33]		<= # dly phase_acc[32][38] ? pre_cos[32] + {{33{pre_sin[32][41]}}, pre_sin[32][41:33]} : pre_cos[32] - {{33{pre_sin[32][41]}}, pre_sin[32][41:33]};
	pre_sin[33]		<= # dly phase_acc[32][38] ? pre_sin[32] - {{33{pre_cos[32][41]}}, pre_cos[32][41:33]} : pre_sin[32] + {{33{pre_cos[32][41]}}, pre_cos[32][41:33]};
end

always@(posedge clk) begin
	phase_acc[34]	<= # dly phase_acc[33][38] ? phase_acc[33] + atan[34] : phase_acc[33] - atan[34];
	pre_cos[34]		<= # dly phase_acc[33][38] ? pre_cos[33] + {{34{pre_sin[33][41]}}, pre_sin[33][41:34]} : pre_cos[33] - {{34{pre_sin[33][41]}}, pre_sin[33][41:34]};
	pre_sin[34]		<= # dly phase_acc[33][38] ? pre_sin[33] - {{34{pre_cos[33][41]}}, pre_cos[33][41:34]} : pre_sin[33] + {{34{pre_cos[33][41]}}, pre_cos[33][41:34]};
end

always@(posedge clk) begin
	phase_acc[35]	<= # dly phase_acc[34][38] ? phase_acc[34] + atan[35] : phase_acc[34] - atan[35];
	pre_cos[35]		<= # dly phase_acc[34][38] ? pre_cos[34] + {{35{pre_sin[34][41]}}, pre_sin[34][41:35]} : pre_cos[34] - {{35{pre_sin[34][41]}}, pre_sin[34][41:35]};
	pre_sin[35]		<= # dly phase_acc[34][38] ? pre_sin[34] - {{35{pre_cos[34][41]}}, pre_cos[34][41:35]} : pre_sin[34] + {{35{pre_cos[34][41]}}, pre_cos[34][41:35]};
end

assign cos_out	= pre_cos[35][41:6];
assign sin_out	= pre_sin[35][41:6];
					
endmodule