`timescale 1ns/1ns

module cs4272_dacs( input clrn, lrck, sclk, 
	output sdin,
	output reg lword_req, rword_req,
	input [23:0] word);

parameter dly = 1;	
	
reg [23:0] shreg;
reg old_lrck;
reg [4:0] sh_count;

always @(posedge sclk) begin
	old_lrck	<= # dly lrck;
	rword_req	<= # dly lrck && ~old_lrck;
	lword_req	<= # dly ~lrck && old_lrck;
end

always @(posedge sclk or negedge clrn) begin
	if (~clrn || old_lrck^lrck) begin
		sh_count	<= # dly 5'h0;
	end else begin
		sh_count	<= # dly sh_count + 1'b1;
	end
end
			 		
always @(negedge sclk) begin
	if (&sh_count) begin
		shreg	<= # dly word;
	end else begin
		shreg <= # dly {shreg[22:0], 1'b0};
	end
end

assign sdin	= shreg[23];

endmodule