`timescale 1ns/1ns

module cs_generator(
	input [23:2] vme_addr,
	output cs_int_manager,
	output cs_vwbtn,
	output cs_codec,
	output cs_vert_sram_master,
	output cs_hor_sram_master,
	output cs_pm_sram_master,
	output w_mem_cs,
	output cs_trigger_manager,
	output cs_fir_dec,
	output cs_cordic_win_1,
	output cs_cordic_win_2,
	output cs_cordic_win_3,
	output cs_debug_reg);

assign cs_int_manager		= vme_addr[23:4] ==20'h0;		// FROM 00_0000 (addr[23:0])		
assign cs_debug_reg			= vme_addr[23:6] ==18'h0efba;	// FROM 3B_EE80 (addr[23:0])		
assign cs_vwbtn				= vme_addr[23:6] ==18'h0efbb;   // FROM 3B_EEC0 (addr[23:0])        
assign cs_trigger_manager	= vme_addr[23:6] ==18'h0efbc;	// FROM 3B_EF00 (addr[23:0])
assign cs_cordic_win_1		= vme_addr[23:6] ==18'h0efbd;   // FROM 3B_EF40 (addr[23:0])
assign cs_cordic_win_2		= vme_addr[23:6] ==18'h0efbe;   // FROM 3B_EF80 (addr[23:0])    
assign cs_cordic_win_3		= vme_addr[23:6] ==18'h0efbf;   // FROM 3B_EFC0 (addr[23:0]) 
assign cs_codec				= vme_addr[23:10]==14'h0efe;	// FROM 3B_F800 (addr[23:0])           
assign cs_fir_dec			= vme_addr[23:10]==14'h0eff;	// FROM 3B_FC00 (addr[23:0])        
assign w_mem_cs				= vme_addr[23:18]==6'h0f;		// FROM 3C_0000 (addr[23:0])         
assign cs_vert_sram_master	= vme_addr[23:22]==2'h1;		// FROM 40_0000 (addr[23:0])
assign cs_hor_sram_master	= vme_addr[23:22]==2'h2;		// FROM 80_0000 (addr[23:0])
assign cs_pm_sram_master	= vme_addr[23:22]==2'h3;		// FROM C0_0000 (addr[23:0])

endmodule      