`timescale 1ns/1ns

module fft4 (input clk, dav,
	input [1:0] index,
	input [31:0] x_r, x_i,
	output reg [33:0] X0_r, X0_i,
	output reg [33:0] X1_r, X1_i,
	output reg [33:0] X2_r, X2_i,
	output reg [33:0] X3_r, X3_i);

parameter dly = 1;	
		
wire [33:0] x_r_ext, x_i_ext;

assign x_r_ext = {{2{x_r[31]}},x_r};
assign x_i_ext = {{2{x_i[31]}},x_i};


always @(posedge clk) begin
	if (dav) begin
		case (index)
		2'h0: begin
			X0_r	<= # dly x_r_ext;
			X0_i	<= # dly x_i_ext;
			X1_r	<= # dly x_r_ext;
			X1_i	<= # dly x_i_ext;
			X2_r	<= # dly x_r_ext;
			X2_i	<= # dly x_i_ext;
			X3_r	<= # dly x_r_ext;
			X3_i	<= # dly x_i_ext;
		end
		2'h1: begin
			X0_r	<= # dly X0_r + x_r_ext;
			X0_i	<= # dly X0_i + x_i_ext;
			X1_r	<= # dly X1_r + x_i_ext;
			X1_i	<= # dly X1_i - x_r_ext;
			X2_r	<= # dly X2_r - x_r_ext;
			X2_i	<= # dly X2_i - x_i_ext;
			X3_r	<= # dly X3_r - x_i_ext;
			X3_i	<= # dly X3_i + x_r_ext;
		end                            
		2'h2: begin                    
			X0_r	<= # dly X0_r + x_r_ext;
			X0_i	<= # dly X0_i + x_i_ext;
			X1_r	<= # dly X1_r - x_r_ext;
			X1_i	<= # dly X1_i - x_i_ext;
			X2_r	<= # dly X2_r + x_r_ext;
			X2_i	<= # dly X2_i + x_i_ext;
			X3_r	<= # dly X3_r - x_r_ext;
			X3_i	<= # dly X3_i - x_i_ext;
		end                            
		2'h3: begin                    
			X0_r	<= # dly X0_r + x_r_ext;
			X0_i	<= # dly X0_i + x_i_ext;
			X1_r	<= # dly X1_r - x_i_ext;
			X1_i	<= # dly X1_i + x_r_ext;
			X2_r	<= # dly X2_r - x_r_ext;
			X2_i	<= # dly X2_i - x_i_ext;
			X3_r	<= # dly X3_r + x_i_ext;
			X3_i	<= # dly X3_i - x_r_ext;
		end	
		endcase
	end
end

endmodule  