`timescale 1 ns/ 1 ns

module fft_module_arbiter (
	clk, 
	clrn,
	req_ch1,
	req_ch2,
	grant_ch1,
	grant_ch2,
	fft_start_ch1,
	fft_iteration_ch1,
	fft_n_2_ch1,
	fft_x_t_ch1,
	fft_start_ch2,
	fft_iteration_ch2,
	fft_n_2_ch2,
	fft_x_t_ch2,
	fft_start_out,
	fft_iteration_out,
	fft_n_2_out,
	fft_x_t_out);
	
input clk;
input clrn;

input req_ch1;
input req_ch2;
output grant_ch1;
output grant_ch2; 

input	fft_start_ch1;
input	[3:0] fft_iteration_ch1;
input	[15:0] fft_n_2_ch1;
input	[31:0] fft_x_t_ch1;

input	fft_start_ch2;
input	[3:0] fft_iteration_ch2;
input	[15:0] fft_n_2_ch2;
input	[31:0] fft_x_t_ch2;


output	fft_start_out;          
output	[3:0] fft_iteration_out;
output	[15:0] fft_n_2_out;     
output	[31:0] fft_x_t_out;     
        
parameter dly = 1;

reg active_channel;

always @ (posedge clk or negedge clrn) begin
	if (~clrn) begin
		active_channel	<= # dly 1'b0;
	end else if (req_ch1^req_ch2) begin
		active_channel	<= # dly req_ch2;
	end else if (~(req_ch1||req_ch2)) begin
		active_channel	<= # dly 1'b0; //in case of concurrent request priority to channel 1 : removing this will give priority to the last served channel
	end
end

assign grant_ch1	= req_ch1 && ~active_channel;
assign grant_ch2	= req_ch2 && active_channel;

assign fft_start_out		= active_channel ? fft_start_ch2 : fft_start_ch1 ;
assign fft_iteration_out	= active_channel ? fft_iteration_ch2 : fft_iteration_ch1 ;
assign fft_n_2_out			= active_channel ? fft_n_2_ch2 : fft_n_2_ch1 ;     
assign fft_x_t_out			= active_channel ? fft_x_t_ch2 : fft_x_t_ch1 ;     
		
endmodule 