`timescale 1 ns/ 1 ns

module half_compl_mult_36x36 (
	clk,
	x_r, x_i,
	w_r, w_i,
	r_i,
	result);  //2 level of ppl!!!

input clk;		
input [35:0] x_r, x_i, w_r, w_i;
input r_i;
output [72:0] result;

reg [72:0] result;

parameter dly = 1;

wire [35:0] mult1_ina, mult1_inb, mult2_ina, mult2_inb;
wire [71:0] prod1, prod2;

assign mult1_ina	= x_r;
assign mult1_inb	= r_i	? w_r : w_i;

assign mult2_ina	= x_i;
assign mult2_inb	= r_i	? -w_i : w_r;

always @(posedge clk) result	<= # dly {prod1[71], prod1} + {prod2[71], prod2};

sign_mult_36x36 mult1(
	.clock0(clk),
	.dataa_0(mult1_ina),
	.datab_0(mult1_inb),
	.result(prod1));
	
sign_mult_36x36 mult2(
	.clock0(clk),
	.dataa_0(mult2_ina),
	.datab_0(mult2_inb),
	.result(prod2));
	
endmodule