`timescale 1 ns/ 1 ns

module mean256_40bins (
	input clk, clrn,
	
	input cs,
	input rd,
	input [5:0] addr,
	output reg dout_dav,
	output reg [31:0] dout,
	
	input burst,
	input trigger,
	input [11:0] din);

parameter dly = 1;

reg [19:0] mem_space [39:0];
wire [39:0] selected_bin;

reg [5:0] bin_counter;

wire [19:0] filter_out;

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin
		bin_counter	<= # dly 6'h0;
	end else if (~burst) begin
		bin_counter	<= # dly 6'h0;
	end else if (trigger && bin_counter!=6'd40) begin //protection from exceeding number of trigger per burst
		bin_counter	<= # dly bin_counter + 1'b1;	
	end
end

assign selected_bin	= mem_space[bin_counter];
assign filter_out	= selected_bin - {{8{selected_bin[19]}}, selected_bin[19:8]} + {{8{din[11]}}, din};

always @(posedge clk) begin
	if (burst && trigger) begin
		 mem_space[bin_counter]	<= # dly filter_out;
	end
end

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin
		dout_dav	<= # dly 1'b0;
		dout		<= # dly 32'h0;
	end else if (cs && rd) begin
		dout_dav	<= # dly 1'b1;
		dout		<= # dly {12'h0, mem_space[addr]};
	end
end		 

endmodule
