`timescale 1ns/1ns

module pll_test();

reg clk, clrn;

reg sampling;

reg [39:0] phase;
wire [35:0] I_ampl, Q_ampl;
wire IQ_done, pll_done;
reg [35:0] I_reg, Q_reg;	
 
parameter dly =1;

parameter freq = 40'h00_08f0_0000;

always begin
	clk = 1'b1;
	#12;
	clk	= 1'b0;
	#13;
end
		
initial begin
	clrn	= 1'b1;
	#1; 
	clrn	= 1'b0;
	#100;
	clrn	= 1'b1;
end	

always begin
	#2;
	sampling	= 1'b0;
	#1500;
	sampling	= 1'b1;
	#23;
end

always @(posedge clk or negedge clrn) begin
	if (~clrn) begin
		phase	<= # dly 40'h0;
	end else begin
		phase	<= # dly phase + freq;
	end
end



cordic_rotator_folded cordic_rot_IQ(
	.clk(clk),
	.clrn(clrn),
	.phase_in(phase),
	.start_value({42'd1_000_000_000}),
	.start(sampling),
	.done(IQ_done),
	.cos_out(I_ampl),
	.sin_out(Q_ampl));

always @(posedge IQ_done) begin
	I_reg	<= # dly I_ampl;
	Q_reg	<= # dly Q_ampl;
end

/*
cordic_ampl_phy ampl_and_phase(
	.clk(clk),
	.clrn(clrn),
	.x_in(I_reg),
	.y_in(Q_reg),
	.start(sampling));
*/

q_pll Q_PLL_i(
	.clk(clk),
	.clrn(clrn),
	.start(sampling),
//	.ampl_i(I_reg[35:4]),
	.ampl_i({32'h0}),
	.ampl_q(Q_reg[35:4]),
	.vme_cs({1'b0}));

		 
endmodule