`timescale 1ns/1ns

module vme_dout_arbiter (
	clk, clrn,
	cs_vwbtn, vwbtn_data, vwbtn_dav,
	cs_codec, codec_data, codec_dav,
	cs_vert_sram_master, vert_sram_master_data, vert_sram_master_dav,
	cs_w_mem, w_mem_data, w_mem_dav,
	vme_data, vme_dav);
	
input clk, clrn;

input cs_vwbtn; 
input [31:0] vwbtn_data; 
input vwbtn_dav;

input cs_codec;
input [31:0] codec_data;
input codec_dav;

input cs_vert_sram_master;
input [31:0] vert_sram_master_data;
input vert_sram_master_dav;

input cs_w_mem;
input [31:0] w_mem_data;
input w_mem_dav;

output [31:0] vme_data;
output vme_dav;

reg [31:0] vme_data;
reg vme_dav;

always @(*) begin
	vme_data	= 32'hdead_beef;
	vme_dav		= 1'b0;
	if (cs_vwbtn) begin
		vme_data	= vwbtn_data;
		vme_dav		= vwbtn_dav;
	end else if (cs_codec) begin
		vme_data	= codec_data;
		vme_dav		= codec_dav;
	end else if (cs_vert_sram_master) begin
		vme_data	= vert_sram_master_data;
		vme_dav		= vert_sram_master_dav;
	end else if (cs_w_mem) begin
		vme_data	= w_mem_data;
		vme_dav		= w_mem_dav;
	end
end

endmodule	